\ AIFHEAD.FTH - ARM AIF file header

(( 
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

))

asmcode
  mov r0, r0                            \ NOP if the image is not compressed
  mov r0, r0                            \ NOP if the image is not self-relocating
  mov r0, r0                            \ NOP if the image has no DBGInit/ZeroInit procedure
  bl Vector_Start                       \ BL ImageEntryPoint to make header addressable via R14
                                        \ ... but application should not return here ...
  swi $011                              \ last ditch program exit instruction if we do return
l: AIFimagereadonlysize                 \ Including header size (128bytes) for executable AIF
  dd 0
  dd 0                                  \ Image ReadWrite exact size - a multiple of 4 bytes
  dd 0                                  \ Image Debug exact size - a multiple of 4 bytes
  dd 0                                  \ Image zero-init exact size - a multiple of 4 bytes
  dd 0                                  \ Image debug type 0/1/2/3
  dd link-address                       \ Image base - address the image (code) was linked at
  dd 0                                  \ Work space - minimum space in bytes to be reserved for
                                        \ a self-moving relocatable image
  dd #32                                \ Address mode: 26/32 +3 flag bytes
  dd 0                                  \ Data base - address the image data was linked at
  dd 0                                  \ Reserved word - initially 0
  dd 0                                  \ Reserved word - initially 0
  mov r0, r0                            \ Debug Init instr - NOP if unused
  dd 0                                  \ Zero-init code - 14 words as below
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
  dd 0
l: EndofAIFheader
end-code


