\ Test code for KEB50100 board

((
Copyright (c) 2002
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

only forth definitions  decimal


\ *********************************
\ Memory system and byte lane tests
\ *********************************

((
: LDUMP		\ addr u -- ; dump 32 bit long words
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i @ .lword  4 +loop	\ first eight bytes
    space  i $010 + i 8 +               \ gap
    do  space i @ .lword  4 +loop	\ second eight bytes
    2 spaces  i $010 + i                \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $010 +loop                            \ until done
  cr  					\ restore base
;

: WDUMP		\ addr u -- ; dump 16 bit half words
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i w@ .word  2 +loop	\ first eight bytes
    space  i $010 + i 8 +               \ gap
    do  space i w@ .word  2 +loop	\ second eight bytes
    2 spaces  i $010 + i                \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $010 +loop                            \ until done
  cr  					\ restore base
;

: CDUMP		\ addr u -- ; dump 8 bit bytes
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i c@ .byte  loop          \ first eight bytes
    space  i 010 + i 8 +                \ gap
    do  space i c@ .byte  loop          \ second eight bytes
    2 spaces  i 010 + i                 \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $10 +loop                             \ until done
  cr  					\ restore base
;
))

