\ CPU startup on NMI9200 board with AT91RM9200

CPU=ARM9le			\ select CPU type

: InitFlash	\ --
  $00000002 $FFFFFF60 l!c(t)	\ EBI_CSA: Setup MEMC to support CS1=SDRAM, CS0=Flash
  $00000000 $FFFFFF64 l!c(t)	\ EBI_CFGR: Data bus pulled up
  $3301328B $FFFFFF70 l!c(t)	\ SMC_CSR0:
\ No early read, DBW=1, BAT=1, 2 data float, 7 w/s
  $00000002 $FFFFFF60 l!c(t)	\ EBI_CSA: Setup MEMC to support CS1=SDRAM, CS0=Flash
;

: InitTarget	\ --
  4 SetJtagSpeed		\ in case of 32 kHz
  ['] (StopCPU) catch if	\ try twice to stop cpu
    #100 ms (StopCPU)
  endif
  $D3 WriteCPSR			\ SVC mode, I/F set
  InitFlash
  $FF01 $FFFFFC20 l!c(t)	\ Enable main osc: CKGR_MOR
  #100 ms
  $20263E04 $FFFFFC28 l!c(t) #20 ms	\ PLLA
  $10483E0E $FFFFFC2C l!c(t) #20 ms	\ PLLB
       $202 $FFFFFC30 l!c(t) #20 ms	\ MCK
         $1 $FFFFFC00 l!c(t) #20 ms	\ Enable PCK
  #1000 setJTAGspeed
;

