\ RebootLPC210x.fth - Reboots Philips LPC210x CPUs

((
Copyright (c) 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal

\ ==========
\ *! rebootlpc210x
\ *T Rebooting the CPU
\ ==========
\ *P The word *\fo{REBOOT} permits the system to be reset by
\ ** disabling all interrupts and activating the watchdog.

: reboot	\ --
\ *G Reboots the CPU by activating the watchdog.
  di  _WD
  $200 over WDTC + !			\ time period = 512
  3 over WDMOD + !			\ enable for reset
  $AA over WDFEED + !			\ feed sequence
  $55 swap WDFEED + !
  begin again				\ wait for reset
;


\ ======
\ *> ###
\ ======

decimal

