\ MPE ROM PowerForth Forth extension tool set

((
TOOLS.FTH

Copyright (c) 1991..2002
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

May 1991	Converted to text file
))

\ ===========
\ *> romforth
\ *S Some simple tools
\ ===========
\ *P The file *\i{COMMON\ROMFORTH\TOOLS.FTH} provides some simple
\ ** application tools.

\ *P The words *\fo{(#IN)} and *\fo{#IN} are provided to collect
\ ** numbers from the keyboard in decimal. *\fo{(#IN)} is useful
\ ** because it returns the number of digits converted so that 0
\ ** digits indicates that the user just pressed <Enter>, rather
\ ** than entering a valid number of value 0.

decimal

: (#in)		\ -- n #chars
\ *G Read a decimal number from the keyboard returning the number
\ ** and the number of digits converted.
  0 0					\ n=0, #chars=0
  begin
    key dup #13 <>			\ while key is not CR
   while
    dup #10 digit if			\ digit?
      swap emit				\ y:, echo it
      rot #10 * +			\     accumulate it
      swap 1+				\     count it
    else
      8 = if				\ n:, backspace character?
        dup if				\     y:, remove last character
          swap #10 /			\         divide total by 10
	  swap 1-			\         reduce count
	  bs				\         wipe out character
	endif
      endif
    endif
  repeat
  drop  ;				\ discard CR

: #in		\ -- n
\ *G Collect a decimal number from the keyboard.
  0					\ initial value
  begin  drop (#in)  until  ;		\ keep trying until valid


\ ======
\ *> ###
\ ======

decimal

