\
\ simple tests / examples of checksum/crc
\

\ there are 7 types of checksum / crc supported:
\
\     simple8 - 8bit checksum
\    simple16 - 16bit checksum
\    simple32 - 32bit checksum
\       ccitt - 16bit crc
\      lrcc16 - 16bit crc
\      sdlc16 - 16bit crc
\       crc16 - 16bit crc


\ ------------------------------------------------------------------------------
\ This result should be: $10
create result2 0 ,

create testbuffer2  #16 allot
  testbuffer2 #16 1 fill

testbuffer2 dup #15 + result2 simple8 checksum


\ ------------------------------------------------------------------------------
\ This result should be: $0808

create result3 0 ,

create testbuffer3  #16 allot
  testbuffer3 #16 1 fill

testbuffer3 dup #15 + result3 simple16 checksum


\ ------------------------------------------------------------------------------
\ This result should be: $04040404
create result4 0 ,

create testbuffer4  #16 allot
  testbuffer4 #16 1 fill

testbuffer4 dup #15 + result4 simple32 checksum


\ ------------------------------------------------------------------------------
\ This result should be: $7DC5
create result5 0 ,

create testbuffer5
  ", THE,QUICK,BROWN,FOX,0123456789"

testbuffer5 1+ dup #29 + result5 ccitt checksum


\ ------------------------------------------------------------------------------
\ This result should be: ????
create result6 0 ,

create testbuffer6
  ", THE,QUICK,BROWN,FOX,0123456789"

testbuffer6 1+ dup #29 + result6 lrcc16 checksum


\ ------------------------------------------------------------------------------
\ This result should be: $DF91
create result7 0 ,

create testbuffer7
  ", THE,QUICK,BROWN,FOX,0123456789"

testbuffer7 1+ dup #29 + result7 sdlc checksum


\ ------------------------------------------------------------------------------
\ This result should be: $B96E
create result8 0 ,

create testbuffer8
  ", THE,QUICK,BROWN,FOX,0123456789"

testbuffer8 1+ dup #29 + result8 crc16 checksum

