\
\ Simple tests / examples of structures and local variables
\

4 field-type int                \ create FIELD-TYPES
8 field-type long

struct fred                     \ create a STRUCT
  int		fred1           \ use a FIELD-TYPE
  4 field	fred2           \ use a FIELD
  long		fred3
end-struct

idata                           \ an instance of a structure in IDATA
create blah  fred allot
cdata


\ write to the members of the structure using literals
\ execute test1 and dump BLAH, you should see:
\	 $AAAAAAAA, $55555555, $11111111, $22222222
\
: TEST1  (  --  )
  $aaaaaaaa blah fred1 !
  $55555555 blah fred2 !
  $11111111,22222222 blah fred3 2!
;

\ write to members of a local structure using local variables
\ execute test2, the first dump should show zeros
\ the second dump should show:
\       x4, x3, x2, x1 where x? are the values of the input parameters
\
: TEST2  {  x1 x2 x3 x4 | buff[ fred ]  --  }
  buff[ fred erase
  buff[ fred dump
  x4 buff[ fred1 !
  x3 buff[ fred2 !
  x1 x2 buff[ fred3 2!
  buff[ fred dump
;

