\ dump.fth - DUMP and friends

((
Released for use with the MPE Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: +44 (0)1703 631441
tel: +44 (0)1703 339691
))

\ ***************
\ Debugging tools
\ ***************

: .BYTE         \ n --
  base @ >r hex
  0 <# # # #> TYPE
  r> base !
;

: .WORD         \ n --
  base @ >r hex
  0 <# # # # # #> TYPE
  r> base !
;

32bit? [if]
: .DWORD        \ n --
  base @ >r hex
  0 <# # # # # [char] . hold # # # # #> TYPE
  r> base !
;
[then]

: .ASCII        \ b --
  $07F AND  DUP $020 $07E WITHIN? 0=
  IF  DROP $02E  ENDIF  EMIT
;

16bit? [if]
: dump		\ addr len --
  BASE @ -rot  HEX  bounds		\ get limits
  ?DO
    CR  i .WORD  i 010 bounds		\ print address
    do  space  i c@ .BYTE  loop		\ print byte
    2 SPACES  I 010 bounds		\ gap
    DO  I c@ .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  010 +LOOP				\ until done
  BASE !  CR				\ restore base
;

harvard? [if]
: Cdump		\ addr len --
  BASE @ -rot  HEX  bounds		\ get limits
  ?DO
    CR  i .WORD  i 010 bounds		\ print address
    do  space  i c@c .BYTE  loop	\ print byte
    2 SPACES  I 010 bounds		\ gap
    DO  I c@c .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  010 +LOOP				\ until done
  BASE !  CR				\ restore base
;
[then]
[then]

32bit? [if]
: dump		\ addr len --
  BASE @ -rot  HEX  bounds		\ get limits
  ?DO
    CR  i .DWORD  i 010 bounds		\ print address
    do  space  i c@ .BYTE  loop		\ print byte
    2 SPACES  I 010 bounds		\ gap
    DO  I c@ .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  010 +LOOP				\ until done
  BASE !  CR				\ restore base
;

harvard? [if]
: Cdump		\ addr len --
  BASE @ -rot  HEX  bounds		\ get limits
  ?DO
    CR  i .DWORD  i 010 bounds		\ print address
    do  space  i c@c .BYTE  loop	\ print byte
    2 SPACES  I 010 bounds		\ gap
    DO  I c@c .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  010 +LOOP				\ until done
  BASE !  CR				\ restore base
;
[then]
[then]

: .S		\ i*x -- i*x
  CR
  DEPTH ?DUP IF
    ."  top"  0
    DO  I PICK CR 8 U.R  LOOP
  ELSE
    ." Empty stack"
  ENDIF
  CR
;

