#! /bin/bash
# Run during installation from the root directory of the installation

# Install the compiler(s) and VFX Forth to /usr/local/bin
sudo cp -p  Compiler/xArmCortexHfp_x64_mac.mo  /usr/local/bin/
# sudo cp -p  Compiler/xArmCortex_x64_mac.mo     /usr/local/bin/
sudo cp -p  Compiler/Vfx*_x64_mac.mo           /usr/local/bin/

# Install the MPE shared libraries to /usr/local/lib
sudo cp -p  Compiler/*64.dylib                 /usr/local/lib/

# Install the Segger shared libraries to /usr/local/lib
# We do not have written permission from Segger yet.

sudo cd /usr/local/bin
# if [ -e xArmCortex_x64_mac.mo ]; then
#   if [ -e xArmCortex ]; then
#     sudo rm xArmCortex
#   fi
#   ln -s xArmCortex_x64_mac.mo xArmCortex
# fi
if [ -e xArmCortexHfp_x64_mac.mo ]; then
  if [ -e xArmCortexHfp ]; then
    sudo rm xArmCortexHfp
  fi
  ln -s xArmCortexHfp_x64_mac.mo xArmCortexHfp
fi
cd -

