#! /bin/bash
# *** Builds Forth 7 for ARM Cortex manual

# *** build HTML and TeX files
rm *.html
rm *.tex
vfx64  include MakeCortex.dgs

# *** make PDF and clean up
# copy *.tex texfiles
cp ../Images/*.pdf .
pdftex manual.tex
texindex manual.fn
pdftex manual.tex
texindex manual.fn
pdftex manual.tex

mv manual.pdf CortexMan.pdf
mv manual.tex CortexMan.tex
mv manual.log CortexMan.log
mv manual.fn  CortexMan.fn
mv manual.fns CortexMan.fns
rm manual.*
mv CortexMan.pdf manual.pdf
mv CortexMan.tex manual.tex
mv CortexMan.log manual.log
mv CortexMan.fn  manual.fn
mv CortexMan.fns manual.fns
# *** delete trivia and TeX files
# del ###.html
rm *.tex

ls manual.*

# *** save last copy
cp  manual.pdf ../PDFs/ArmCortexMan.pdf
cp  manual.fns ../PDFs/ArmCortexMan.vix
rm  ../xARM.htm/*
cp  *.html     ../xArmCortex.htm/
cp  *.css      ../xArmCortex.htm/
rm  *.html
cp  ../Images/*.jpg  ../xArmCortex.htm/
cp  ../Images/*.png  ../xArmCortex.htm/
cp  ../Images/*.gif  ../xArmCortex.htm/

# *** all done
echo Read and then delete MANUAL.LOG.
