\ Atmel ATSAM4SD32C Microcontroller

((
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp


This file produced by the MPE SVDconv utility
on Wed, 19 Oct 2016 18:45:26.


Atmel ATSAM4SD32C Microcontroller
CPU: CM4, r0p1
  Endian: selectable
  MPU: true
  FPU: false
  NVIC priority bits: 4
  Vendor Systick Config: false
))


\ ======================================
\ HSMCI - High Speed MultiMedia Card Interface
\ ======================================

$4000:0000 equ _HSMCI
#34 equ HSMCI_IRQn
  $0000 equ mmc.CR               \ Control Register
  $0004 equ mmc.MR               \ Mode Register
  $0008 equ mmc.DTOR             \ Data Timeout Register
  $000C equ mmc.SDCR             \ SD/SDIO Card Register
  $0010 equ mmc.ARGR             \ Argument Register
  $0014 equ mmc.CMDR             \ Command Register
  $0018 equ mmc.BLKR             \ Block Register
  $001C equ mmc.CSTOR            \ Completion Signal Timeout Register
  $0020 equ mmc.RSPR[%s]         \ Response Register
  $0030 equ mmc.RDR              \ Receive Data Register
  $0034 equ mmc.TDR              \ Transmit Data Register
  $0040 equ mmc.SR               \ Status Register
  $0044 equ mmc.IER              \ Interrupt Enable Register
  $0048 equ mmc.IDR              \ Interrupt Disable Register
  $004C equ mmc.IMR              \ Interrupt Mask Register
  $0054 equ mmc.CFG              \ Configuration Register
  $00E4 equ mmc.WPMR             \ Write Protection Mode Register
  $00E8 equ mmc.WPSR             \ Write Protection Status Register
  $0200 equ mmc.FIFO[%s]         \ FIFO Memory Aperture0
  $0100 equ mmc.RPR              \ Receive Pointer Register
  $0104 equ mmc.RCR              \ Receive Counter Register
  $0108 equ mmc.TPR              \ Transmit Pointer Register
  $010C equ mmc.TCR              \ Transmit Counter Register
  $0110 equ mmc.RNPR             \ Receive Next Pointer Register
  $0114 equ mmc.RNCR             \ Receive Next Counter Register
  $0118 equ mmc.TNPR             \ Transmit Next Pointer Register
  $011C equ mmc.TNCR             \ Transmit Next Counter Register
  $0120 equ mmc.PTCR             \ Transfer Control Register
  $0124 equ mmc.PTSR             \ Transfer Status Register


\ ======================================
\ SSC - Synchronous Serial Controller
\ ======================================

$4000:4000 equ _SSC
#38 equ SSC_IRQn
  $0000 equ ssc.CR               \ Control Register
  $0004 equ ssc.CMR              \ Clock Mode Register
  $0010 equ ssc.RCMR             \ Receive Clock Mode Register
  $0014 equ ssc.RFMR             \ Receive Frame Mode Register
  $0018 equ ssc.TCMR             \ Transmit Clock Mode Register
  $001C equ ssc.TFMR             \ Transmit Frame Mode Register
  $0020 equ ssc.RHR              \ Receive Holding Register
  $0024 equ ssc.THR              \ Transmit Holding Register
  $0030 equ ssc.RSHR             \ Receive Sync. Holding Register
  $0034 equ ssc.TSHR             \ Transmit Sync. Holding Register
  $0038 equ ssc.RC0R             \ Receive Compare 0 Register
  $003C equ ssc.RC1R             \ Receive Compare 1 Register
  $0040 equ ssc.SR               \ Status Register
  $0044 equ ssc.IER              \ Interrupt Enable Register
  $0048 equ ssc.IDR              \ Interrupt Disable Register
  $004C equ ssc.IMR              \ Interrupt Mask Register
  $00E4 equ ssc.WPMR             \ Write Protection Mode Register
  $00E8 equ ssc.WPSR             \ Write Protection Status Register
  $0100 equ ssc.RPR              \ Receive Pointer Register
  $0104 equ ssc.RCR              \ Receive Counter Register
  $0108 equ ssc.TPR              \ Transmit Pointer Register
  $010C equ ssc.TCR              \ Transmit Counter Register
  $0110 equ ssc.RNPR             \ Receive Next Pointer Register
  $0114 equ ssc.RNCR             \ Receive Next Counter Register
  $0118 equ ssc.TNPR             \ Transmit Next Pointer Register
  $011C equ ssc.TNCR             \ Transmit Next Counter Register
  $0120 equ ssc.PTCR             \ Transfer Control Register
  $0124 equ ssc.PTSR             \ Transfer Status Register


\ ======================================
\ SPI - Serial Peripheral Interface
\ ======================================

$4000:8000 equ _SPI
#37 equ SPI_IRQn
  $0000 equ spi.CR               \ Control Register
  $0004 equ spi.MR               \ Mode Register
  $0008 equ spi.RDR              \ Receive Data Register
  $000C equ spi.TDR              \ Transmit Data Register
  $0010 equ spi.SR               \ Status Register
  $0014 equ spi.IER              \ Interrupt Enable Register
  $0018 equ spi.IDR              \ Interrupt Disable Register
  $001C equ spi.IMR              \ Interrupt Mask Register
  $0030 equ spi.CSR[%s]          \ Chip Select Register
  $00E4 equ spi.WPMR             \ Write Protection Mode Register
  $00E8 equ spi.WPSR             \ Write Protection Status Register
  $0100 equ spi.RPR              \ Receive Pointer Register
  $0104 equ spi.RCR              \ Receive Counter Register
  $0108 equ spi.TPR              \ Transmit Pointer Register
  $010C equ spi.TCR              \ Transmit Counter Register
  $0110 equ spi.RNPR             \ Receive Next Pointer Register
  $0114 equ spi.RNCR             \ Receive Next Counter Register
  $0118 equ spi.TNPR             \ Transmit Next Pointer Register
  $011C equ spi.TNCR             \ Transmit Next Counter Register
  $0120 equ spi.PTCR             \ Transfer Control Register
  $0124 equ spi.PTSR             \ Transfer Status Register


\ ======================================
\ TC0/1 - Timer Counter 0/1
\ ======================================

$4001:0000 equ _TC0
#39 equ TC0_IRQn
#40 equ TC1_IRQn
#41 equ TC2_IRQn
$4001:4000 equ _TC1
#42 equ TC3_IRQn
#43 equ TC4_IRQn
#44 equ TC5_IRQn
  $0000 equ tc.CCR0              \ Channel Control Register (channel = 0)
  $0004 equ tc.CMR0              \ Channel Mode Register (channel = 0)
  $0004 equ tc.CMR0_WAVEFORM_MODE \ Channel Mode Register (channel = 0)
  $0008 equ tc.SMMR0             \ Stepper Motor Mode Register (channel = 0)
  $0010 equ tc.CV0               \ Counter Value (channel = 0)
  $0014 equ tc.RA0               \ Register A (channel = 0)
  $0018 equ tc.RB0               \ Register B (channel = 0)
  $001C equ tc.RC0               \ Register C (channel = 0)
  $0020 equ tc.SR0               \ Status Register (channel = 0)
  $0024 equ tc.IER0              \ Interrupt Enable Register (channel = 0)
  $0028 equ tc.IDR0              \ Interrupt Disable Register (channel = 0)
  $002C equ tc.IMR0              \ Interrupt Mask Register (channel = 0)
  $0040 equ tc.CCR1              \ Channel Control Register (channel = 1)
  $0044 equ tc.CMR1              \ Channel Mode Register (channel = 1)
  $0044 equ tc.CMR1_WAVEFORM_MODE \ Channel Mode Register (channel = 1)
  $0048 equ tc.SMMR1             \ Stepper Motor Mode Register (channel = 1)
  $0050 equ tc.CV1               \ Counter Value (channel = 1)
  $0054 equ tc.RA1               \ Register A (channel = 1)
  $0058 equ tc.RB1               \ Register B (channel = 1)
  $005C equ tc.RC1               \ Register C (channel = 1)
  $0060 equ tc.SR1               \ Status Register (channel = 1)
  $0064 equ tc.IER1              \ Interrupt Enable Register (channel = 1)
  $0068 equ tc.IDR1              \ Interrupt Disable Register (channel = 1)
  $006C equ tc.IMR1              \ Interrupt Mask Register (channel = 1)
  $0080 equ tc.CCR2              \ Channel Control Register (channel = 2)
  $0084 equ tc.CMR2              \ Channel Mode Register (channel = 2)
  $0084 equ tc.CMR2_WAVEFORM_MODE \ Channel Mode Register (channel = 2)
  $0088 equ tc.SMMR2             \ Stepper Motor Mode Register (channel = 2)
  $0090 equ tc.CV2               \ Counter Value (channel = 2)
  $0094 equ tc.RA2               \ Register A (channel = 2)
  $0098 equ tc.RB2               \ Register B (channel = 2)
  $009C equ tc.RC2               \ Register C (channel = 2)
  $00A0 equ tc.SR2               \ Status Register (channel = 2)
  $00A4 equ tc.IER2              \ Interrupt Enable Register (channel = 2)
  $00A8 equ tc.IDR2              \ Interrupt Disable Register (channel = 2)
  $00AC equ tc.IMR2              \ Interrupt Mask Register (channel = 2)
  $00C0 equ tc.BCR               \ Block Control Register
  $00C4 equ tc.BMR               \ Block Mode Register
  $00C8 equ tc.QIER              \ QDEC Interrupt Enable Register
  $00CC equ tc.QIDR              \ QDEC Interrupt Disable Register
  $00D0 equ tc.QIMR              \ QDEC Interrupt Mask Register
  $00D4 equ tc.QISR              \ QDEC Interrupt Status Register
  $00D8 equ tc.FMR               \ Fault Mode Register
  $00E4 equ tc.WPMR              \ Write Protection Mode Register


\ ======================================
\ TWI0/1 - Two-wire Interface 0/1
\ ======================================

$4001:8000 equ _TWI0
#35 equ TWI0_IRQn
$4001:C000 equ _TWI1
#36 equ TWI1_IRQn
  $0000 equ i2c.CR               \ Control Register
  $0004 equ i2c.MMR              \ Master Mode Register
  $0008 equ i2c.SMR              \ Slave Mode Register
  $000C equ i2c.IADR             \ Internal Address Register
  $0010 equ i2c.CWGR             \ Clock Waveform Generator Register
  $0020 equ i2c.SR               \ Status Register
  $0024 equ i2c.IER              \ Interrupt Enable Register
  $0028 equ i2c.IDR              \ Interrupt Disable Register
  $002C equ i2c.IMR              \ Interrupt Mask Register
  $0030 equ i2c.RHR              \ Receive Holding Register
  $0034 equ i2c.THR              \ Transmit Holding Register
  $0100 equ i2c.RPR              \ Receive Pointer Register
  $0104 equ i2c.RCR              \ Receive Counter Register
  $0108 equ i2c.TPR              \ Transmit Pointer Register
  $010C equ i2c.TCR              \ Transmit Counter Register
  $0110 equ i2c.RNPR             \ Receive Next Pointer Register
  $0114 equ i2c.RNCR             \ Receive Next Counter Register
  $0118 equ i2c.TNPR             \ Transmit Next Pointer Register
  $011C equ i2c.TNCR             \ Transmit Next Counter Register
  $0120 equ i2c.PTCR             \ Transfer Control Register
  $0124 equ i2c.PTSR             \ Transfer Status Register


\ ======================================
\ PWM - Pulse Width Modulation Controller
\ ======================================

$4002:0000 equ _PWM
#47 equ PWM_IRQn
  $0000 equ pwm.CLK              \ PWM Clock Register
  $0004 equ pwm.ENA              \ PWM Enable Register
  $0008 equ pwm.DIS              \ PWM Disable Register
  $000C equ pwm.SR               \ PWM Status Register
  $0010 equ pwm.IER1             \ PWM Interrupt Enable Register 1
  $0014 equ pwm.IDR1             \ PWM Interrupt Disable Register 1
  $0018 equ pwm.IMR1             \ PWM Interrupt Mask Register 1
  $001C equ pwm.ISR1             \ PWM Interrupt Status Register 1
  $0020 equ pwm.SCM              \ PWM Sync Channels Mode Register
  $0028 equ pwm.SCUC             \ PWM Sync Channels Update Control Register
  $002C equ pwm.SCUP             \ PWM Sync Channels Update Period Register
  $0030 equ pwm.SCUPUPD          \ PWM Sync Channels Update Period Update Register
  $0034 equ pwm.IER2             \ PWM Interrupt Enable Register 2
  $0038 equ pwm.IDR2             \ PWM Interrupt Disable Register 2
  $003C equ pwm.IMR2             \ PWM Interrupt Mask Register 2
  $0040 equ pwm.ISR2             \ PWM Interrupt Status Register 2
  $0044 equ pwm.OOV              \ PWM Output Override Value Register
  $0048 equ pwm.OS               \ PWM Output Selection Register
  $004C equ pwm.OSS              \ PWM Output Selection Set Register
  $0050 equ pwm.OSC              \ PWM Output Selection Clear Register
  $0054 equ pwm.OSSUPD           \ PWM Output Selection Set Update Register
  $0058 equ pwm.OSCUPD           \ PWM Output Selection Clear Update Register
  $005C equ pwm.FMR              \ PWM Fault Mode Register
  $0060 equ pwm.FSR              \ PWM Fault Status Register
  $0064 equ pwm.FCR              \ PWM Fault Clear Register
  $0068 equ pwm.FPV              \ PWM Fault Protection Value Register
  $006C equ pwm.FPE              \ PWM Fault Protection Enable Register
  $007C equ pwm.ELMR[%s]         \ PWM Event Line 0 Mode Register
  $00B0 equ pwm.SMMR             \ PWM Stepper Motor Mode Register
  $00E4 equ pwm.WPCR             \ PWM Write Protection Control Register
  $00E8 equ pwm.WPSR             \ PWM Write Protection Status Register
  $0130 equ pwm.CMPV0            \ PWM Comparison 0 Value Register
  $0134 equ pwm.CMPVUPD0         \ PWM Comparison 0 Value Update Register
  $0138 equ pwm.CMPM0            \ PWM Comparison 0 Mode Register
  $013C equ pwm.CMPMUPD0         \ PWM Comparison 0 Mode Update Register
  $0140 equ pwm.CMPV1            \ PWM Comparison 1 Value Register
  $0144 equ pwm.CMPVUPD1         \ PWM Comparison 1 Value Update Register
  $0148 equ pwm.CMPM1            \ PWM Comparison 1 Mode Register
  $014C equ pwm.CMPMUPD1         \ PWM Comparison 1 Mode Update Register
  $0150 equ pwm.CMPV2            \ PWM Comparison 2 Value Register
  $0154 equ pwm.CMPVUPD2         \ PWM Comparison 2 Value Update Register
  $0158 equ pwm.CMPM2            \ PWM Comparison 2 Mode Register
  $015C equ pwm.CMPMUPD2         \ PWM Comparison 2 Mode Update Register
  $0160 equ pwm.CMPV3            \ PWM Comparison 3 Value Register
  $0164 equ pwm.CMPVUPD3         \ PWM Comparison 3 Value Update Register
  $0168 equ pwm.CMPM3            \ PWM Comparison 3 Mode Register
  $016C equ pwm.CMPMUPD3         \ PWM Comparison 3 Mode Update Register
  $0170 equ pwm.CMPV4            \ PWM Comparison 4 Value Register
  $0174 equ pwm.CMPVUPD4         \ PWM Comparison 4 Value Update Register
  $0178 equ pwm.CMPM4            \ PWM Comparison 4 Mode Register
  $017C equ pwm.CMPMUPD4         \ PWM Comparison 4 Mode Update Register
  $0180 equ pwm.CMPV5            \ PWM Comparison 5 Value Register
  $0184 equ pwm.CMPVUPD5         \ PWM Comparison 5 Value Update Register
  $0188 equ pwm.CMPM5            \ PWM Comparison 5 Mode Register
  $018C equ pwm.CMPMUPD5         \ PWM Comparison 5 Mode Update Register
  $0190 equ pwm.CMPV6            \ PWM Comparison 6 Value Register
  $0194 equ pwm.CMPVUPD6         \ PWM Comparison 6 Value Update Register
  $0198 equ pwm.CMPM6            \ PWM Comparison 6 Mode Register
  $019C equ pwm.CMPMUPD6         \ PWM Comparison 6 Mode Update Register
  $01A0 equ pwm.CMPV7            \ PWM Comparison 7 Value Register
  $01A4 equ pwm.CMPVUPD7         \ PWM Comparison 7 Value Update Register
  $01A8 equ pwm.CMPM7            \ PWM Comparison 7 Mode Register
  $01AC equ pwm.CMPMUPD7         \ PWM Comparison 7 Mode Update Register
  $0200 equ pwm.CMR0             \ PWM Channel Mode Register (ch_num = 0)
  $0204 equ pwm.CDTY0            \ PWM Channel Duty Cycle Register (ch_num = 0)
  $0208 equ pwm.CDTYUPD0         \ PWM Channel Duty Cycle Update Register (ch_num = 0)
  $020C equ pwm.CPRD0            \ PWM Channel Period Register (ch_num = 0)
  $0210 equ pwm.CPRDUPD0         \ PWM Channel Period Update Register (ch_num = 0)
  $0214 equ pwm.CCNT0            \ PWM Channel Counter Register (ch_num = 0)
  $0218 equ pwm.DT0              \ PWM Channel Dead Time Register (ch_num = 0)
  $021C equ pwm.DTUPD0           \ PWM Channel Dead Time Update Register (ch_num = 0)
  $0220 equ pwm.CMR1             \ PWM Channel Mode Register (ch_num = 1)
  $0224 equ pwm.CDTY1            \ PWM Channel Duty Cycle Register (ch_num = 1)
  $0228 equ pwm.CDTYUPD1         \ PWM Channel Duty Cycle Update Register (ch_num = 1)
  $022C equ pwm.CPRD1            \ PWM Channel Period Register (ch_num = 1)
  $0230 equ pwm.CPRDUPD1         \ PWM Channel Period Update Register (ch_num = 1)
  $0234 equ pwm.CCNT1            \ PWM Channel Counter Register (ch_num = 1)
  $0238 equ pwm.DT1              \ PWM Channel Dead Time Register (ch_num = 1)
  $023C equ pwm.DTUPD1           \ PWM Channel Dead Time Update Register (ch_num = 1)
  $0240 equ pwm.CMR2             \ PWM Channel Mode Register (ch_num = 2)
  $0244 equ pwm.CDTY2            \ PWM Channel Duty Cycle Register (ch_num = 2)
  $0248 equ pwm.CDTYUPD2         \ PWM Channel Duty Cycle Update Register (ch_num = 2)
  $024C equ pwm.CPRD2            \ PWM Channel Period Register (ch_num = 2)
  $0250 equ pwm.CPRDUPD2         \ PWM Channel Period Update Register (ch_num = 2)
  $0254 equ pwm.CCNT2            \ PWM Channel Counter Register (ch_num = 2)
  $0258 equ pwm.DT2              \ PWM Channel Dead Time Register (ch_num = 2)
  $025C equ pwm.DTUPD2           \ PWM Channel Dead Time Update Register (ch_num = 2)
  $0260 equ pwm.CMR3             \ PWM Channel Mode Register (ch_num = 3)
  $0264 equ pwm.CDTY3            \ PWM Channel Duty Cycle Register (ch_num = 3)
  $0268 equ pwm.CDTYUPD3         \ PWM Channel Duty Cycle Update Register (ch_num = 3)
  $026C equ pwm.CPRD3            \ PWM Channel Period Register (ch_num = 3)
  $0270 equ pwm.CPRDUPD3         \ PWM Channel Period Update Register (ch_num = 3)
  $0274 equ pwm.CCNT3            \ PWM Channel Counter Register (ch_num = 3)
  $0278 equ pwm.DT3              \ PWM Channel Dead Time Register (ch_num = 3)
  $027C equ pwm.DTUPD3           \ PWM Channel Dead Time Update Register (ch_num = 3)
  $0108 equ pwm.TPR              \ Transmit Pointer Register
  $010C equ pwm.TCR              \ Transmit Counter Register
  $0118 equ pwm.TNPR             \ Transmit Next Pointer Register
  $011C equ pwm.TNCR             \ Transmit Next Counter Register
  $0120 equ pwm.PTCR             \ Transfer Control Register
  $0124 equ pwm.PTSR             \ Transfer Status Register


\ ======================================
\ USART0/1 - Universal Synchronous Asynchronous Receiver Transmitter 0/1
\ ======================================

$4002:4000 equ _USART0
#30 equ USART0_IRQn
$4002:8000 equ _USART1
#31 equ USART1_IRQn
  $0000 equ USn.CR               \ Control Register
  $0000 equ USn.CR_SPI_MODE      \ Control Register
  $0004 equ USn.MR               \ Mode Register
  $0004 equ USn.MR_SPI_MODE      \ Mode Register
  $0008 equ USn.IER              \ Interrupt Enable Register
  $0008 equ USn.IER_SPI_MODE     \ Interrupt Enable Register
  $000C equ USn.IDR              \ Interrupt Disable Register
  $000C equ USn.IDR_SPI_MODE     \ Interrupt Disable Register
  $0010 equ USn.IMR              \ Interrupt Mask Register
  $0010 equ USn.IMR_SPI_MODE     \ Interrupt Mask Register
  $0014 equ USn.CSR              \ Channel Status Register
  $0014 equ USn.CSR_SPI_MODE     \ Channel Status Register
  $0018 equ USn.RHR              \ Receive Holding Register
  $001C equ USn.THR              \ Transmit Holding Register
  $0020 equ USn.BRGR             \ Baud Rate Generator Register
  $0024 equ USn.RTOR             \ Receiver Time-out Register
  $0028 equ USn.TTGR             \ Transmitter Timeguard Register
  $0040 equ USn.FIDI             \ FI DI Ratio Register
  $0044 equ USn.NER              \ Number of Errors Register
  $004C equ USn.IF               \ IrDA Filter Register
  $0050 equ USn.MAN              \ Manchester Configuration Register
  $00E4 equ USn.WPMR             \ Write Protection Mode Register
  $00E8 equ USn.WPSR             \ Write Protection Status Register
  $0100 equ USn.RPR              \ Receive Pointer Register
  $0104 equ USn.RCR              \ Receive Counter Register
  $0108 equ USn.TPR              \ Transmit Pointer Register
  $010C equ USn.TCR              \ Transmit Counter Register
  $0110 equ USn.RNPR             \ Receive Next Pointer Register
  $0114 equ USn.RNCR             \ Receive Next Counter Register
  $0118 equ USn.TNPR             \ Transmit Next Pointer Register
  $011C equ USn.TNCR             \ Transmit Next Counter Register
  $0120 equ USn.PTCR             \ Transfer Control Register
  $0124 equ USn.PTSR             \ Transfer Status Register


\ ======================================
\ UDP - USB Device Port
\ ======================================

$4003:4000 equ _UDP
#50 equ UDP_IRQn
  $0000 equ udp.FRM_NUM          \ Frame Number Register
  $0004 equ udp.GLB_STAT         \ Global State Register
  $0008 equ udp.FADDR            \ Function Address Register
  $0010 equ udp.IER              \ Interrupt Enable Register
  $0014 equ udp.IDR              \ Interrupt Disable Register
  $0018 equ udp.IMR              \ Interrupt Mask Register
  $001C equ udp.ISR              \ Interrupt Status Register
  $0020 equ udp.ICR              \ Interrupt Clear Register
  $0028 equ udp.RST_EP           \ Reset Endpoint Register
  $0030 equ udp.CSR[%s]          \ Endpoint Control and Status Register
  $0030 equ udp.CSR0_ISOCHRONOUS \ Endpoint Control and Status Register
  $0050 equ udp.FDR[%s]          \ Endpoint FIFO Data Register
  $0074 equ udp.TXVC             \ Transceiver Control Register


\ ======================================
\ ADC - Analog-to-Digital Converter
\ ======================================

$4003:8000 equ _ADC
#45 equ ADC_IRQn
  $0000 equ adc.CR               \ Control Register
  $0004 equ adc.MR               \ Mode Register
  $0008 equ adc.SEQR1            \ Channel Sequence Register 1
  $000C equ adc.SEQR2            \ Channel Sequence Register 2
  $0010 equ adc.CHER             \ Channel Enable Register
  $0014 equ adc.CHDR             \ Channel Disable Register
  $0018 equ adc.CHSR             \ Channel Status Register
  $0020 equ adc.LCDR             \ Last Converted Data Register
  $0024 equ adc.IER              \ Interrupt Enable Register
  $0028 equ adc.IDR              \ Interrupt Disable Register
  $002C equ adc.IMR              \ Interrupt Mask Register
  $0030 equ adc.ISR              \ Interrupt Status Register
  $003C equ adc.OVER             \ Overrun Status Register
  $0040 equ adc.EMR              \ Extended Mode Register
  $0044 equ adc.CWR              \ Compare Window Register
  $0048 equ adc.CGR              \ Channel Gain Register
  $004C equ adc.COR              \ Channel Offset Register
  $0050 equ adc.CDR[%s]          \ Channel Data Register
  $0094 equ adc.ACR              \ Analog Control Register
  $00E4 equ adc.WPMR             \ Write Protection Mode Register
  $00E8 equ adc.WPSR             \ Write Protection Status Register
  $0100 equ adc.RPR              \ Receive Pointer Register
  $0104 equ adc.RCR              \ Receive Counter Register
  $0110 equ adc.RNPR             \ Receive Next Pointer Register
  $0114 equ adc.RNCR             \ Receive Next Counter Register
  $0120 equ adc.PTCR             \ Transfer Control Register
  $0124 equ adc.PTSR             \ Transfer Status Register


\ ======================================
\ DACC - Digital-to-Analog Converter Controller
\ ======================================

$4003:C000 equ _DACC
#46 equ DACC_IRQn
  $0000 equ dac.CR               \ Control Register
  $0004 equ dac.MR               \ Mode Register
  $0010 equ dac.CHER             \ Channel Enable Register
  $0014 equ dac.CHDR             \ Channel Disable Register
  $0018 equ dac.CHSR             \ Channel Status Register
  $0020 equ dac.CDR              \ Conversion Data Register
  $0024 equ dac.IER              \ Interrupt Enable Register
  $0028 equ dac.IDR              \ Interrupt Disable Register
  $002C equ dac.IMR              \ Interrupt Mask Register
  $0030 equ dac.ISR              \ Interrupt Status Register
  $0094 equ dac.ACR              \ Analog Current Register
  $00E4 equ dac.WPMR             \ Write Protection Mode Register
  $00E8 equ dac.WPSR             \ Write Protection Status Register
  $0108 equ dac.TPR              \ Transmit Pointer Register
  $010C equ dac.TCR              \ Transmit Counter Register
  $0118 equ dac.TNPR             \ Transmit Next Pointer Register
  $011C equ dac.TNCR             \ Transmit Next Counter Register
  $0120 equ dac.PTCR             \ Transfer Control Register
  $0124 equ dac.PTSR             \ Transfer Status Register


\ ======================================
\ ACC - Analog Comparator Controller
\ ======================================

$4004:0000 equ _ACC
#49 equ ACC_IRQn
  $0000 equ acc.CR               \ Control Register
  $0004 equ acc.MR               \ Mode Register
  $0024 equ acc.IER              \ Interrupt Enable Register
  $0028 equ acc.IDR              \ Interrupt Disable Register
  $002C equ acc.IMR              \ Interrupt Mask Register
  $0030 equ acc.ISR              \ Interrupt Status Register
  $0094 equ acc.ACR              \ Analog Control Register
  $00E4 equ acc.WPMR             \ Write Protection Mode Register
  $00E8 equ acc.WPSR             \ Write Protection Status Register


\ ======================================
\ CRCCU - Cyclic Redundancy Check Calculation Unit
\ ======================================

$4004:4000 equ _CRCCU
#48 equ CRCCU_IRQn
  $0000 equ crc.DSCR             \ CRCCU Descriptor Base Register
  $0008 equ crc.DMA_EN           \ CRCCU DMA Enable Register
  $000C equ crc.DMA_DIS          \ CRCCU DMA Disable Register
  $0010 equ crc.DMA_SR           \ CRCCU DMA Status Register
  $0014 equ crc.DMA_IER          \ CRCCU DMA Interrupt Enable Register
  $0018 equ crc.DMA_IDR          \ CRCCU DMA Interrupt Disable Register
  $001C equ crc.DMA_IMR          \ CRCCU DMA Interrupt Mask Register
  $0020 equ crc.DMA_ISR          \ CRCCU DMA Interrupt Status Register
  $0034 equ crc.CR               \ CRCCU Control Register
  $0038 equ crc.MR               \ CRCCU Mode Register
  $003C equ crc.SR               \ CRCCU Status Register
  $0040 equ crc.IER              \ CRCCU Interrupt Enable Register
  $0044 equ crc.IDR              \ CRCCU Interrupt Disable Register
  $0048 equ crc.IMR              \ CRCCU Interrupt Mask Register
  $004C equ crc.ISR              \ CRCCU Interrupt Status Register


\ ======================================
\ CMCC - Cortex-M Cache Controller
\ ======================================

$4007:C000 equ _CMCC
  $0000 equ cmc.TYPE             \ Cache Controller Type Register
  $0004 equ cmc.CFG              \ Cache Controller Configuration Register
  $0008 equ cmc.CTRL             \ Cache Controller Control Register
  $000C equ cmc.SR               \ Cache Controller Status Register
  $0020 equ cmc.MAINT0           \ Cache Controller Maintenance Register 0
  $0024 equ cmc.MAINT1           \ Cache Controller Maintenance Register 1
  $0028 equ cmc.MCFG             \ Cache Controller Monitor Configuration Register
  $002C equ cmc.MEN              \ Cache Controller Monitor Enable Register
  $0030 equ cmc.MCTRL            \ Cache Controller Monitor Control Register
  $0034 equ cmc.MSR              \ Cache Controller Monitor Status Register


\ ======================================
\ SMC - Static Memory Controller
\ ======================================

$400E:0000 equ _SMC
  $0000 equ smc.SETUP0           \ SMC Setup Register (CS_number = 0)
  $0004 equ smc.PULSE0           \ SMC Pulse Register (CS_number = 0)
  $0008 equ smc.CYCLE0           \ SMC Cycle Register (CS_number = 0)
  $000C equ smc.MODE0            \ SMC MODE Register (CS_number = 0)
  $0010 equ smc.SETUP1           \ SMC Setup Register (CS_number = 1)
  $0014 equ smc.PULSE1           \ SMC Pulse Register (CS_number = 1)
  $0018 equ smc.CYCLE1           \ SMC Cycle Register (CS_number = 1)
  $001C equ smc.MODE1            \ SMC MODE Register (CS_number = 1)
  $0020 equ smc.SETUP2           \ SMC Setup Register (CS_number = 2)
  $0024 equ smc.PULSE2           \ SMC Pulse Register (CS_number = 2)
  $0028 equ smc.CYCLE2           \ SMC Cycle Register (CS_number = 2)
  $002C equ smc.MODE2            \ SMC MODE Register (CS_number = 2)
  $0030 equ smc.SETUP3           \ SMC Setup Register (CS_number = 3)
  $0034 equ smc.PULSE3           \ SMC Pulse Register (CS_number = 3)
  $0038 equ smc.CYCLE3           \ SMC Cycle Register (CS_number = 3)
  $003C equ smc.MODE3            \ SMC MODE Register (CS_number = 3)
  $0080 equ smc.OCMS             \ SMC OCMS MODE Register
  $0084 equ smc.KEY1             \ SMC OCMS KEY1 Register
  $0088 equ smc.KEY2             \ SMC OCMS KEY2 Register
  $00E4 equ smc.WPMR             \ SMC Write Protection Mode Register
  $00E8 equ smc.WPSR             \ SMC Write Protection Status Register


\ ======================================
\ MATRIX - AHB Bus Matrix
\ ======================================

$400E:0200 equ _MATRIX
  $0000 equ MATRIX_MCFG[%s]      \ Master Configuration Register
  $0040 equ MATRIX_SCFG[%s]      \ Slave Configuration Register
  $0080 equ MATRIX_PRAS0         \ Priority Register A for Slave 0
  $0088 equ MATRIX_PRAS1         \ Priority Register A for Slave 1
  $0090 equ MATRIX_PRAS2         \ Priority Register A for Slave 2
  $0098 equ MATRIX_PRAS3         \ Priority Register A for Slave 3
  $00A0 equ MATRIX_PRAS4         \ Priority Register A for Slave 4
  $0114 equ CCFG_SYSIO           \ System I/O Configuration register
  $011C equ CCFG_SMCNFCS         \ SMC Chip Select NAND Flash Assignment Register
  $01E4 equ MATRIX_WPMR          \ Write Protection Mode Register
  $01E8 equ MATRIX_WPSR          \ Write Protection Status Register


\ ======================================
\ PMC - Power Management Controller
\ ======================================

$400E:0400 equ _PMC
#21 equ PMC_IRQn
  $0000 equ PMC_SCER             \ System Clock Enable Register
  $0004 equ PMC_SCDR             \ System Clock Disable Register
  $0008 equ PMC_SCSR             \ System Clock Status Register
  $0010 equ PMC_PCER0            \ Peripheral Clock Enable Register 0
  $0014 equ PMC_PCDR0            \ Peripheral Clock Disable Register 0
  $0018 equ PMC_PCSR0            \ Peripheral Clock Status Register 0
  $0020 equ CKGR_MOR             \ Main Oscillator Register
  $0024 equ CKGR_MCFR            \ Main Clock Frequency Register
  $0028 equ CKGR_PLLAR           \ PLLA Register
  $002C equ CKGR_PLLBR           \ PLLB Register
  $0030 equ PMC_MCKR             \ Master Clock Register
  $0038 equ PMC_USB              \ USB Clock Register
  $0040 equ PMC_PCK[%s]          \ Programmable Clock 0 Register
  $0060 equ PMC_IER              \ Interrupt Enable Register
  $0064 equ PMC_IDR              \ Interrupt Disable Register
  $0068 equ PMC_SR               \ Status Register
  $006C equ PMC_IMR              \ Interrupt Mask Register
  $0070 equ PMC_FSMR             \ Fast Startup Mode Register
  $0074 equ PMC_FSPR             \ Fast Startup Polarity Register
  $0078 equ PMC_FOCR             \ Fault Output Clear Register
  $00E4 equ PMC_WPMR             \ Write Protection Mode Register
  $00E8 equ PMC_WPSR             \ Write Protection Status Register
  $0100 equ PMC_PCER1            \ Peripheral Clock Enable Register 1
  $0104 equ PMC_PCDR1            \ Peripheral Clock Disable Register 1
  $0108 equ PMC_PCSR1            \ Peripheral Clock Status Register 1
  $0110 equ PMC_OCR              \ Oscillator Calibration Register


\ ======================================
\ UART0 - Universal Asynchronous Receiver Transmitter 0
\ ======================================

$400E:0600 equ _UART0
#24 equ UART0_IRQn
$400E:0800 equ _UART1
#25 equ UART1_IRQn
  $0000 equ Un.CR                \ Control Register
  $0004 equ Un.MR                \ Mode Register
  $0008 equ Un.IER               \ Interrupt Enable Register
  $000C equ Un.IDR               \ Interrupt Disable Register
  $0010 equ Un.IMR               \ Interrupt Mask Register
  $0014 equ Un.SR                \ Status Register
  $0018 equ Un.RHR               \ Receive Holding Register
  $001C equ Un.THR               \ Transmit Holding Register
  $0020 equ Un.BRGR              \ Baud Rate Generator Register
  $0100 equ Un.RPR               \ Receive Pointer Register
  $0104 equ Un.RCR               \ Receive Counter Register
  $0108 equ Un.TPR               \ Transmit Pointer Register
  $010C equ Un.TCR               \ Transmit Counter Register
  $0110 equ Un.RNPR              \ Receive Next Pointer Register
  $0114 equ Un.RNCR              \ Receive Next Counter Register
  $0118 equ Un.TNPR              \ Transmit Next Pointer Register
  $011C equ Un.TNCR              \ Transmit Next Counter Register
  $0120 equ Un.PTCR              \ Transfer Control Register
  $0124 equ Un.PTSR              \ Transfer Status Register


\ ======================================
\ CHIPID - Chip Identifier
\ ======================================

$400E:0740 equ _CHIPID
  $0000 equ cid.CIDR             \ Chip ID Register
  $0004 equ cid.EXID             \ Chip ID Extension Register


\ ======================================
\ EFC0/1 - Embedded Flash Controller 0/1
\ ======================================

$400E:0A00 equ _EFC0
#22 equ EFC0_IRQn
$400E:0C00 equ _EFC1
#23 equ EFC1_IRQn
  $0000 equ efc.FMR              \ EEFC Flash Mode Register
  $0004 equ efc.FCR              \ EEFC Flash Command Register
  $0008 equ efc.FSR              \ EEFC Flash Status Register
  $000C equ efc.FRR              \ EEFC Flash Result Register


\ ======================================
\ PIOA/B/C - Parallel Input/Output Controller A/B/C
\ ======================================

$400E:0E00 equ _PIOA
#27 equ PIOA_IRQn
$400E:1000 equ _PIOB
#28 equ PIOB_IRQn
$400E:1200 equ _PIOC
#29 equ PIOC_IRQn
  $0000 equ pio.PER              \ PIO Enable Register
  $0004 equ pio.PDR              \ PIO Disable Register
  $0008 equ pio.PSR              \ PIO Status Register
  $0010 equ pio.OER              \ Output Enable Register
  $0014 equ pio.ODR              \ Output Disable Register
  $0018 equ pio.OSR              \ Output Status Register
  $0020 equ pio.IFER             \ Glitch Input Filter Enable Register
  $0024 equ pio.IFDR             \ Glitch Input Filter Disable Register
  $0028 equ pio.IFSR             \ Glitch Input Filter Status Register
  $0030 equ pio.SODR             \ Set Output Data Register
  $0034 equ pio.CODR             \ Clear Output Data Register
  $0038 equ pio.ODSR             \ Output Data Status Register
  $003C equ pio.PDSR             \ Pin Data Status Register
  $0040 equ pio.IER              \ Interrupt Enable Register
  $0044 equ pio.IDR              \ Interrupt Disable Register
  $0048 equ pio.IMR              \ Interrupt Mask Register
  $004C equ pio.ISR              \ Interrupt Status Register
  $0050 equ pio.MDER             \ Multi-driver Enable Register
  $0054 equ pio.MDDR             \ Multi-driver Disable Register
  $0058 equ pio.MDSR             \ Multi-driver Status Register
  $0060 equ pio.PUDR             \ Pull-up Disable Register
  $0064 equ pio.PUER             \ Pull-up Enable Register
  $0068 equ pio.PUSR             \ Pad Pull-up Status Register
  $0070 equ pio.ABCDSR[%s]       \ Peripheral Select Register
  $0080 equ pio.IFSCDR           \ Input Filter Slow Clock Disable Register
  $0084 equ pio.IFSCER           \ Input Filter Slow Clock Enable Register
  $0088 equ pio.IFSCSR           \ Input Filter Slow Clock Status Register
  $008C equ pio.SCDR             \ Slow Clock Divider Debouncing Register
  $0090 equ pio.PPDDR            \ Pad Pull-down Disable Register
  $0094 equ pio.PPDER            \ Pad Pull-down Enable Register
  $0098 equ pio.PPDSR            \ Pad Pull-down Status Register
  $00A0 equ pio.OWER             \ Output Write Enable
  $00A4 equ pio.OWDR             \ Output Write Disable
  $00A8 equ pio.OWSR             \ Output Write Status Register
  $00B0 equ pio.AIMER            \ Additional Interrupt Modes Enable Register
  $00B4 equ pio.AIMDR            \ Additional Interrupt Modes Disable Register
  $00B8 equ pio.AIMMR            \ Additional Interrupt Modes Mask Register
  $00C0 equ pio.ESR              \ Edge Select Register
  $00C4 equ pio.LSR              \ Level Select Register
  $00C8 equ pio.ELSR             \ Edge/Level Status Register
  $00D0 equ pio.FELLSR           \ Falling Edge/Low-Level Select Register
  $00D4 equ pio.REHLSR           \ Rising Edge/High-Level Select Register
  $00D8 equ pio.FRLHSR           \ Fall/Rise - Low/High Status Register
  $00E0 equ pio.LOCKSR           \ Lock Status
  $00E4 equ pio.WPMR             \ Write Protection Mode Register
  $00E8 equ pio.WPSR             \ Write Protection Status Register
  $0100 equ pio.SCHMITT          \ Schmitt Trigger Register
  $0150 equ pio.PCMR             \ Parallel Capture Mode Register
  $0154 equ pio.PCIER            \ Parallel Capture Interrupt Enable Register
  $0158 equ pio.PCIDR            \ Parallel Capture Interrupt Disable Register
  $015C equ pio.PCIMR            \ Parallel Capture Interrupt Mask Register
  $0160 equ pio.PCISR            \ Parallel Capture Interrupt Status Register
  $0164 equ pio.PCRHR            \ Parallel Capture Reception Holding Register
\ ===================
  $0168 equ pio.RPR              \ Receive Pointer Register
  $016C equ pio.RCR              \ Receive Counter Register
  $0178 equ pio.RNPR             \ Receive Next Pointer Register
  $017C equ pio.RNCR             \ Receive Next Counter Register
  $0188 equ pio.PTCR             \ Transfer Control Register
  $018C equ pio.PTSR             \ Transfer Status Register


\ ======================================
\ RSTC - Reset Controller
\ ======================================

$400E:1400 equ _RSTC
  $0000 equ rst.CR               \ Control Register
  $0004 equ rst.SR               \ Status Register
  $0008 equ rst.MR               \ Mode Register


\ ======================================
\ SUPC - Supply Controller
\ ======================================

$400E:1410 equ _SUPC
  $0000 equ suc.CR               \ Supply Controller Control Register
  $0004 equ suc.SMMR             \ Supply Controller Supply Monitor Mode Register
  $0008 equ suc.MR               \ Supply Controller Mode Register
  $000C equ suc.WUMR             \ Supply Controller Wake-up Mode Register
  $0010 equ suc.WUIR             \ Supply Controller Wake-up Inputs Register
  $0014 equ suc.SR               \ Supply Controller Status Register


\ ======================================
\ RTT - Real-time Timer
\ ======================================

$400E:1430 equ _RTT
  $0000 equ rtt.MR               \ Mode Register
  $0004 equ rtt.AR               \ Alarm Register
  $0008 equ rtt.VR               \ Value Register
  $000C equ rtt.SR               \ Status Register


\ ======================================
\ WDT - Watchdog Timer
\ ======================================

$400E:1450 equ _WDT
  $0000 equ wdt.CR               \ Control Register
  $0004 equ wdt.MR               \ Mode Register
  $0008 equ wdt.SR               \ Status Register


\ ======================================
\ RTC - Real-time Clock
\ ======================================

$400E:1460 equ _RTC
  $0000 equ rtc.CR               \ Control Register
  $0004 equ rtc.MR               \ Mode Register
  $0008 equ rtc.TIMR             \ Time Register
  $000C equ rtc.CALR             \ Calendar Register
  $0010 equ rtc.TIMALR           \ Time Alarm Register
  $0014 equ rtc.CALALR           \ Calendar Alarm Register
  $0018 equ rtc.SR               \ Status Register
  $001C equ rtc.SCCR             \ Status Clear Command Register
  $0020 equ rtc.IER              \ Interrupt Enable Register
  $0024 equ rtc.IDR              \ Interrupt Disable Register
  $0028 equ rtc.IMR              \ Interrupt Mask Register
  $002C equ rtc.VER              \ Valid Entry Register


\ ======================================
\ GPBR - General Purpose Backup Registers
\ ======================================

$400E:1490 equ _GPBR
  $0000 equ GPBR[%s]             \ General Purpose Backup Register