\ Diagnostics for MPE Forth Cross compiler v4.x	     sfp 19/09/89

((

Copyright (C) 1989, 1992

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: +44 (0)23 8063 1441

SFP001	26 Aug 1998	Moved all code to XC-SYMBL.FTH
))

\ Max-Nfa [ Words using a thread table ].	    sfp 24/04/89

only forth  also c-c definitions

decimal
(( Moved to XC-SYMBL.FTH
variable Nfa-Buff	\ -- addr
  64 cell* allot	\ must be large enough for max number of threads

: Max-Nfa	\ -- addr nfa ; return buffer address and NFA of highest NFA
  0 0					\ clear result
  nfa-buff				\ data in working buffer
  Context(s) @(m) #threads(s)+ @(s)	\ for all threads
  cell* bounds
  Do
    i @ over u>				\ if greater than current highest
    If	2drop i i @  Endif		\ replace current set
  Cell +Loop  ;				\ step on


\ .word-name					   sfp 17/05/91

: .word-name	\ symbol-addr -- ; show name neatly aligned
  tab					\ go to start of display
  dup count(s) nip  31 and		\ length of string
  out @ +  79 >				\ will it overflow line?
  if  cr  endif				\ yes, new line
  .name(s)  ;				\ finally show name


\ Words(s) [ uses a thread table ] ......	   sfp 17/05/91

: Words(s)	\ -- ; display words in current symbol voc.
  c/l out !				\ set up
  Context(s) @(m) #Threads(s)+		\ #threads, thr0..thrn-1
  dup cell+  nfa-buff			\ source, dest
  rot @(s) cell* cmove(s)>		\ count/length and copy
  Begin
    max-nfa dup				\ while still one left
    halt? 0= and			\ and no stop command
   While
    dup .word-name			\ show name
    cell- @(s) swap !			\ find next NFA in thread
  Repeat
  2drop	 ;
))

\ all done

;p
