\ XDTC41-4.FTH   MPE Forth Cross-Compiler.

((
Copyright (c) 1983-2005, 2006, 2009, 2010, 2012, 2014, 2017, 2020

MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
net: mpe@mpeforth.com


To do
=====
Improve configuration of +/-FLASHCOMPILE(T) and friends.


Reverse chronological change history
====================================
20200319 SFP080 Updated conditional compilation check.
201911xx SFP079 v5.1 changes.
20180525 SFP078 Changes for VFX v5.0 NDCS host.
20170310 SFP077 Added condition compilation checks to
		XC-INCLUDE-FILE.
20140125 SFP076 Added Flash option for immediate bit = 0.
20120612 SFP075 Updated XC-INCLUDE-FILE.
20120505 SFP074 Updated INCLUDE for VFX v4.6.
20100915 SFP073 Variable number of target threads in voc.
20090210 SFP072 Added NOHEADER(T) for :NONAME.
20090512 SFP071 Removed IRTC references.
20080912 SFP070 Changed file release system.
20070301 SFP069 Added ShowCurrSource to XC-Error.
20060316 SFP068	Added page display for 16 bit systems
20040106 SFP067	Added EXTEND_COMPILER handling to TO and ADDR.
20030322 SFP066 Added forward reference marking which is NOT removed.
20030321 SFP065 Improved EXTEND_COMPILER mode.
SFP064  13 June 2001    Added target source file tracking hooks.
SFP063	08 Apr 2001	Added target mode conversion of 16 bit doubles.
			Added D. to interpreter.
SFP062	21 Mar 2001	Enhanced EXTEND_INTERPRETER mode.
SFP061  22 Aug 2000	Changed METHOD-LIT? to handle USER vars and so on.
SFP060	22 July 2000	Changed ROM-VOC(T) and RAM-VOC(T) to prepare for more
			flexible definition of VOCABULARY and addition of WORDLIST.
SFP059	18 June 2000	Added more compilation of ADDR
SFP058	2 June 2000	Added IRTC code
SFP057	24 May 2000	Rewrote extension interpret/compile
SFP056	19 may 2000	Added compiled code size report to ($FROM)
SFP055	15 may 2000	Factored out COMPILE-C/V
SFP054	8 Feb 2000	Added M",C(T) and M",D(T) which expand macros
SFP053  10 Sept 1999	Corrected literal behaviour in EXTEND_COMPILER
SFP052  20 July 1999    Refactored HEADER(T) and TARGET-CREATE  *** N.B. Stack changes ***
SFP051  19 July 1999    Incorporated SJC's requirements for HEADER(T) and IMMEDIATE(T)
                        Moved SJC header code to VFXHEAD.FTH
SFP050  2 June 1999     Corrected ROM-VOC(T) for 16 bit ANS targets
SFP049  4 Apr 1999      Added FIELD optimiser support
                        Corrected "is redefined" message spacing
SJC048  3 Dec 1998      Added line# field to SJC-HEADER
SFP047  17 Nov 1998     Added line counter for final report
SFP046  14 Nov 1998     Modified ($FROM) to update file number
                        Added SET-LOCATE to forward references
                        Added ADD-XREF to forward references
SFP045  8 Nov 1998      Added Harvard update
SJC044  14 Aug 1998     Changed structure in dictionary for RAM VOCABULARY
                        in an attempt to resolve the target side disagreement
                        between WORDLIST and VOCABULARY over what constitues
                        a 'wid'.
SFP043  13 Sep 1998     Factored reDEFERring of ERROR and friends
SFP042  26 Aug 1998     Cleaned up comments
                        Removed C-IF C-ELSE C-ENDIF as no longer used
                        Added WORDS(U) from UFORTH.FTH
SFP041  24 Aug 1998     Reorganised number handling
                        a) to make it saner
                        b) to cope better with FP numbers
SFP040  14 Aug 1998     Added paging support to vocabulary section

Previous chronological change history
=====================================
        Aug 92          converted to PC PowerForth/386 v2

SFP001  14 May 96       Default to CALL xx yy for forward refs

JL001   2 September 96  Split INTERPRET(CC) into HOST-INTERPRET and TARGET-INTERPRET.
                        Modified HOST-INTERPRET so that it will also search the symbol table and
                        compile references.

JL002   11 September 96 Modified tokens to V2.

JL003   23 September 96 Removed unrequired DEFER of ERROR.

JL004   30 September 96.Changed USERVAR to take a LIT not an inline value.

JL005   2 October 96    Put file name display in $FROM.

JL006   2 October 96    Put Final 'PRESS ENTER...' message always to windows.

JL007   4 October 96    Fixed compile time action for children of [TLV-CREATE.

JL008   7 October 96    Removed method support for TLV: as per spec.

JL009   17 October 96   Tidied error handling.

JL010   17 October 96.  Rationalised LOG text and values.

JL011   17 October 96   Added external symbol table.

JL012   31 October 96   Multiple module support.

JL013   12 November 96  Fixed ['] so that forward references use new mode 3 (32bit offset).

JL014   15 November 96  Fixed COMPILE-IMPORT-MOD for 32BIT types.

JL015   19 November 96  Added support for ['] imports.

SFP016  23 Jan 97       Added LOCATE facilities to $FROM

SFP017  31 Jan 97       Added METHOD> support to TO

SFP018  5 Feb 97        modified XC-EXIT to give access to compiler

SFP019  6 Feb 97        Added support for generalised HERE C, W, , ALIGN ALIGNED CREATE

SFP020  11 Feb 97       Added C/V LABEL and EQUATE suppord for EXTEND_xxx modes

SFP021  18 Feb 97       Forced data alignment in CREATE(cc) using GALIGN(T)

SFP022  21 Feb 97       Changed $FROM to reduce screen delays when no log is required

SFP023  17 Mar 97       Changed LIT handling to refer to compilers in GENERATE.FTH
                        Especially affects forward reference handling for [']

JL024   24 Sep 97       Added PG's bug fix for $FORWARD-SYM.

JL025    1 Oct 97       Modified to lay inline literals for CONSTANTS and VARIABLES.

JL026    1 Oct 97       Modified for PFW 2.100

JL027    6 Oct 97       Removed marking of a CREATE symbol as a C/V which allows
                        USERVAR defined target defining words to GENERATE.FTH
                        children words that are correctly referenced - the cost
                        of which is to stop inline literals being generated for
                        CREATEd words (VARIABLES, CONSTANTS and so on still fine).

SFP028  11 Nov 97       Converted to new sections memory model

JL029   13 Oct 97       Reworked vocabulary creation to allows for consistent word
                        list support.

JL030   25 Nov 97       Fixed bug in THREAD, using wrong HERE(T)

JL031   25 Nov 97       Fixed bug in TARGET-CREATE, using wrong HERE(T)

JL032   28 Nov 97       Added PCR for resume file message.

JL033    9 Dec 97       Fixed bug with cross interpreted CREATEd definition.

MSD034  22 Jan 98       Remove the ?BL-EVEN from ",C(T).

SFP035  22 Feb 98       Fixed XC-EXIT

SFP036  28 Feb 98       Moved code generation in CREATE(CC) to XGENxxx

SFP037  29 April 1998   Made double number conversion sensitive to a switch
                        Added HOST-MATH TARGET-MATH D>N
                        Made CONSTANTs and VARIABLEs compile their xts
                        when MPE_STANDARD? is true.
                        Made ROM-VOC(T) sensitive to MPE_STANDARD?

SFP038  29 June 1998    Deferred target header generation

SFP039  2 July 1998     Moved target analogues to XOPTxxx file
))


\ file and vocabulary control

only forth also c-c definitions
decimal


\ ************************************
\ Closing compilation - error or abort
\ ************************************

: close-image   \ -- ; close image, whether emulator or file
  close-sections
\  extsym-close-file
\  extexp-close-file
;

: host-mode-compiler    \ -- ; set system to act in host mode
  assign .SysPrompt  to-do .prompt
\  assign (error) to-do error
\  assign (abort) to-do abort
  assign (quit)  to-do quit
  assign (interpret) to-do interpret
;

: XC-Exit       \ -- ;
\ *sfp* order
  interactive-run @(m) if		\ launch in interactive mode?
    cr ." *** Press ENTER to quit, ESC to enter compiler ***"        \ give the user a chance to see!!
    begin
      key dup $01B = if                 \ SFP018
        only forth  also c-c definitions
        host-mode-compiler              \ SFP042
        cr abort
      endif
      ANL =
    until
  Endif
  bye
;

: Error-Exit    \ -- ; error displayed by caller, give up now
  ShowCurrSource			\ SFP069
  close-image close-log xc-exit
;

: XC-Error      \ error# -- ; replacement for ERROR
  logout @(m)                           \ if not to screen
  if  dup .throw  endif			\   first to log
  close-log
  .throw				\ now to screen
  ShowCurrSource			\ SFP069
  ?releaseFiles				\ release any open source files ; SFP070
  close-image
  xc-exit
;

((
: XC-Fromfile-error	\ n -- ; SFP069
  ShowCurrSource (Fromfile-error)
;  assign XC-Fromfile-error to-do Fromfile-error
))

: Abort-Compilation     \ -- ; user pressed ^C
  close-log  close-image                \ close log file & image
  cr cr
  cr ." *****************************"
  cr ."     USER INTERVENTION      "
  cr ."  CROSS COMPILING ABANDONED  "
  cr ." *****************************"
  only Forth definitions
  xc-exit
;

: Abandon       \ --
  key? if
    key 3 =                           \  was it a control-C ?
    If  abort-compilation  Else  key drop  Endif
  Endif
;


\ ********************
\ Host symbol creation
\ ********************

: (HOST-CREATE)         \ -- ; make symbol head
  here $create(s)
;

: Resolved-Symbol       \ n -- sym-val-fld
  (host-create)  ,(s) zero,(s)
  is-resolved last'(s)@
;

: Host-create   \ xt(t) --
  here Current(s) @(m) #Threads(s)+ v-find(s) \ Symbol exists ?
  If                                    \  Yes,
    dup resolved?                       \   Symbol resolved ?
    If                                  \    Yes,
      drop
      cr  here .name ."  is redefined in the target" cr \ Redefine it, SFP049
      resolved-symbol
      1 #redefined +!(m)
     Else                               \ Otherwise,
      dup set-locate(s)                 \   update LOCATE information   SFP046
      dup -rot resolve                  \   resolve it,
    Endif                               \   mark as target symbol
   Else
    drop resolved-symbol
  Endif
  'latest(s) !(m)                       \ addr of last host
;                                       \ symbol in target

: resolve-sym	\ xt(t) sym -- ; see satisfy(t)
  dup resolved?				\ already resolved?
  if  2drop  exit  then			\   nothing to do
  dup set-locate(s)			\ where defined
  dup -rot resolve			\ resolve links
;


\ ************************
\ Target head construction
\ ************************

variable DefnType       \ -- addr ; holds type of definitions
  0 constant CreateChild        \ enumerate the available types
  1 constant CodeChild
  2 constant ColonChild

variable <:noname>	\ -- addr ; true between :NONAME and ; or DOES> or ;CODE
  <:noname> off

: cur-voc(s)            \ -- addr(s)
  current(s) @(m)  ;            \ current target voc

: cur-#threads(t)       \ -- n
  cur-voc(s)                    \ current voc
  #threads(t)+ @(s)  ;          \ number of threads in it

: thread,                       \ --
  here c@  here 1+ c@ +         \ count + first letter
  cur-#threads(t) 1- and cell*  \ mask to get hash code
  cur-voc(s) t-nfa+ +           \ index into nfas
  dup @(s) ,c(t)                \ lay down old value
  chere(t) swap !(s) ;          \ and update nfas table         \ ***JL030***
\  here(t) swap !(s) ;           \ and update nfas table

$80 value CountMask(t)	\ -- mask
\ Mask for control/Count byte in target header.
\ In normal use,        bit 7 = 1, bit 6 = 0. Bit 6 = immediate bit
\ In Flash compilation: bit 7 = 1, bit 6 = 1. Bit 6 = immediate bit

: +FlashCompile(t)	\ -- ; Set up for compilation to Flash. SFP076
  $C0 to CountMask(t)
;
: -FlashCompile(t)	\ -- ; Set up for normal compilation. SFP076
  $80 to CountMask(t)
;

: (noheader(t))	\ -- xt ; for :NONAME ; SFP072
  ?0-even chere(t)
;

: (header(t))   \ -- ; text at HERE                                             \ SFP052
  here DUP C@ WIDTH(T) @(m) MIN ?dup
  IF
    ?0-even				\ link on even boundary
    thread,				\ lay thread link
    chere(t) last(t) !(m)		\ mark NFA              \ ***JL031***
    OVER C@ CountMask(t) OR C,C(T)  0	\ lay control/count byte ; SFP076
    DO  1+ DUP C@ C,C(T)  LOOP    \ and text
    DROP
    ?force-align
  ELSE
    drop  ?force-align
  ENDIF
  DefnType off
;

: (immediate(t))        \ -- ; default version
  $40 'latest(s) @(m) >name(s) set-bit(s)
  width(t) @(m)
  if
    latest(t) $40 toggle-c(t)
  endif
;

defer noheader(t)	\ -- ; for :NONAME ; SFP072
  assign (noheader(t)) to-do noheader(t)
defer header(t)         \ -- ; count does not include the count byte at HERE    \ SFP052
  assign (header(t)) to-do header(t)
defer immediate(t)      \ -- ; needed for user insertion of new header types
  assign (immediate(t)) to-do immediate(t)

: default-headers       \ -- default to MPE convention
  assign (noheader(t)) to-do noheader(t)
  assign (header(t)) to-do header(t)
  assign (immediate(t)) to-do immediate(t)
  -1 ImmVals(t) !(m)
  #31 width(t) !(m)
;

: target-create \ -- xt(t) ; string at HERE, leading link field         \ SFP052
  header(t)
  CHERE(T)                \ CFA is aligned too    \ ***JL031***
((
chere(t) 1 and if
  cr ."  Misaligned XT in TARGET-CREATE"
  cr ." Alignment state is " ?aligning @(m) .
  0 error
endif
))
;

\   ?force-align  HERE(T)  ;              \ CFA is aligned too
\   dup $FF and  $FD $FF within?         \ old style 6502 only
\   if  pcr ." CFA warning at " dup u.  key drop  endif
\ ;

: XC-Create     \ -- ; build target header and host symbol
  ?bound target-create host-create
;


\ ******************
\ Forward references
\ ******************

: Forward-Error \ -- ; error if between CREATE ... DOES>
  ?b-d xcerr_fwdref ?throw
;

: $forward-sym  \ $name -- symbol ; build new symbol, nothing assigned  SFP023
  Forward-Error                         \ error if between CREATE ... DOES>
  $create(s)  2 zeros,(s)               \ build symbol
  SetForward				\ mark word as having been a forward ref ; SFP066
  last'(s)@ ( cell+ )                   \ return symbol address
  dup add-xref                          \ update XREF information       SFP046
;

: Forward-Create        \ mode -- ; build forward ref packet
  Forward-Error
  (host-create) 2 zeros,(s)             \ Forward ref. symbol
  last'(s)@ cell+ swap ref!             \ forward ref. packet
;

: ?FORWARD      \ -- ; build forward reference if appropriate
  INTERP? #-13 ?throw                   \ can't interp forward refs
  R> R> 2DROP                           \ will exit COMPILING/ASSEMBLING
  sc/c(s)                               \ save symbol context/current
  Assembl?                              \ if assembling
  IF                                    \ force LABELS as symbol voc
    'Labels(s) @(m) current(s) !(m)
  ENDIF
  COMPIL?
  IF
    here $forward-sym compile-ref       \ make new symbol, and compile reference to it  SFP023
  ELSE
    1 forward-create                    \ LABEL reference mode
  ENDIF
  rc/c(s)
;

: make-forward  \ -- ; build forward reference if appropriate
  sc/c(s)                               \ save symbol context/current
  case
    INTERP?
    ?of  #-13 throw  endof		\ can't interp forward refs
    Assembl?
    ?of                                 \ assembling:
      'Labels(s) @(m) current(s) !(m)   \ force LABELS as symbol voc
      1 forward-create                  \ LABEL reference mode
    endof
    Compil?
    ?of                                 \ compiling:
      here $forward-sym compile-ref     \ make new symbol, and compile reference to it
    endof
      1 abort" MAKE-FORWARD - internal software error"
  end-case
  rc/c(s)
;


\ *****************
\ Number conversion
\ *****************

\ converts 32bit 'pseudo 16bit' double numbers ( 00000000.xxxxyyyy )
\ to 'true' 16bit double numbers ( xxxx.yyyy )

: Convert-Double16      ( d -- n[l] n[h] ; convert double to 16bit n )
  convert-doubles? @ if
    drop                        \   discard high part
    dup $ffff and               \   low part on stack
    swap $ffff0000 and          \   mask high part
    0 $10000 um/mod  nip        \   leave high part on stack
  endif
;

: UnConvert-Double16	\ n[l] n[h] -- d ; SFP063
  convert-doubles? @ if
    swap $FFFF and swap
    #16 lshift or
    s>d
  endif
;

: Convert-Double32      ( d -- d ; no action required )
;

: UnConvert-Double32    \ d -- d ; no action required ; SFP063
;

also cc/i
: d>n   cc/i    \ d -- d' ; convert to native
  16bit? if
    drop                        \ discard high part
    0 $10000 um/mod             \ convert 32 bit single to 16 bit double
  endif
;

: host-math     \ -- ; no double number conversion
  convert-doubles? off
;

: target-math   \ -- ; enable double number conversion
  convert-doubles? on
;
previous definitions


defer CONVERT-DOUBLE	\ dhost -- dtarget
defer UNCONVERT-DOUBLE	\ dtarget -- dhost ; SFP063

: Assign-Convert-Double \ -- ; set double number handler for 16b or 32b ; SFP063
  16bit? If
    assign convert-double16 to-do convert-double
    assign unconvert-double16 to-do unconvert-double
  Endif
  32bit? If
    assign convert-double32 to-do convert-double
    assign unconvert-double32 to-do unconvert-double
  Endif
;

: Number        \ -- n | d | nil ; obsolete - for compatibility only
  here count isNumber? ?dup if	\ was it a number?
\  here number? ?dup if          \ was it a number?
    2 =                         \ y:
    if  convert-double  endif	\   check for double numbers
  Else                          \ n:
    ?forward                    \   make forward reference
  Endif
;

: compile-number        \ -- ; forward ref not permitted for Umbilical Forth
  here count isNumber? ?dup ?undef	\ valid number?
\  here number? ?dup ?undef              \ valid number?
  dup 2 =
  if  >r convert-double r>  endif
  abs $0FF and                          \  allow for number type classes
  0 swap 1- do                          \  adjust n for DO ... -1 +LOOP
    i roll general-literal              \  lay components of number
  -1 +loop
;

(( from UFORTH.FTH
: Number        \ -- d | n | abort
  here number? dup ?undef
  2 =
  if  convert-double  endif
;

: compile-number        \ -- ; forward ref not permitted for Umbilical Forth
  here number? ?dup ?undef              \ valid number?
  dup 2 =
  if  >r convert-double r>  endif
  abs $0FF and                          \  allow for number type classes
  0 swap 1- do                          \  adjust n for DO ... -1 +LOOP
    i roll general-literal              \  lay components of number
  -1 +loop
;
))


\ ********************************************
\ Factors of ASSEMBLING COMPILING INTERPRETING
\ ********************************************
\ If these words succeed, they leave the *caller*

: ?number       \ -- [f/d/n] ; looks at string at HERE
  here count isNumber? ?dup if		\ see if this is a valid number
\  here number? ?dup if                  \ see if this is a valid number
    dup 2 =
    if  >r  convert-double  r>  endif   \ convert double if necessary
    compil? if                          \ compile if necessary
      abs $0FF and                      \  allow for number type classes
      0 swap 1- do                      \  adjust n for DO ... -1 +LOOP
        i roll general-literal  -1      \  lay components of number
      +loop
    else
      drop                              \ discard numeric code, retaining f/d/n
    endif
    r> drop                             \ leave caller
  endif
;

: ?INTERPRETER
  INTERPRETER CONTEXT-FIND
  IF  execute R> DROP  ENDIF
;

: ?COMPILER
  COMPILER CONTEXT-FIND
  IF  execute R> DROP  ENDIF
;

: ?ASSEMBLER
  ASM-ACCESS CONTEXT-FIND
  IF  execute R> DROP  ENDIF
;

: ?EQUATES
  here 'EQUATES(s) @(m) #threads(s)+ v-find(s)
  IF  @(s) COMPIL?
      IF general-literal ENDIF
      R> DROP
  ELSE  DROP
  ENDIF
;

: ?LABELS
  here 'LABELS(s) @(m) #threads(s)+ v-find(s)
  IF COMPIL?
     IF
       dup doliteralsym,  @(s) ?bd-literal      \ SFP023
     ELSE
       1 REF
     ENDIF
     R> DROP
  ELSE  DROP
  ENDIF
;

: ?C-C
  C-C CONTEXT-FIND
  if  execute  R> DROP
  else  forth context-find
        if  execute  r> drop  endif
  endif
;

: ?c/v          \ -- addr t | f
  here find(t) dup                    \ Look for symbol
  If                                  \ Found it ?
    drop dup c/v?                     \  is it a c/v ?
    If
      cell+ @(s) cell+ TRUE           \   yes, leave addr, flag
     Else
      drop FALSE                      \   no, just leave flag
    Endif
  Endif
;


\ Primitives                                       Jon 10/08/88

( if in <builds ... does> compile name at HERE into x-compiler)
: COMPILE-CC
  ?B-D ( <builds ... does> ? )
  IF  ?c/v  ( target constant or variable )
    if  @(s) postpone literal
    else  ?IN-ROOT  ( in FORTH vocab. ? )
      0>  ( immediate word ? )
      IF  ( yes )  EXECUTE  ( do it )
      ELSE ( no )  compile-word  ( compile it )	\ SFP078
\      ELSE ( no )  compile,  ( compile it )
      ENDIF
    endif
  ENDIF  ;


\ *************
\ FIELD support - SFP049
\ *************

: interp-field          \ addr(t) symbol -- addr'(t)
  field@ +  ;

: compile-field         \ symbol --
  dup c_field-child  ?b-d
  if
    field@  postpone literal  postpone +	\ SFP078
  else
    drop
  endif
;


\ ***************
\ Methods support
\ ***************

: get-method            \ -- symbol ; find symbol address, error if not defined
  get-token find(t) ?undef                      \ error if not already defined
;

: make-methods          \ -- packet(s) ; build a methods packet, includes finding the methods
  here(s)                                       \ address of new extension packet
  Method_Methods ,(s)                           \ type indicator
  0 ,(s)  0 ,(s)                                \ place holders for previous C/V info
  get-method ,(s)  get-method ,(s)  0 ,(s)      \ fetch, store, null methods
;

: set-methods-c/v       \ symbol packet -- ; set symbol C/V infor into packet
  >r
  dup 2c/v?                                     \ save previous C?V info
  if    2c/v@  r> cell+ 2!(s)
  else  c/v@   r> cell+ !(s)
  endif
;

: new-method-packet     \ template -- instance ; copy over template packet
  here(s) swap                                  \ address of instance packet
  6 cells bounds
  ?do  i @(s) ,(s)  cell +loop                  \ build new packet by copying old
;

: set-methods           \ -- ; address of symbol extension template in-line, builds new one
  'latest(s) @(m) status+ mark-method   \ mark last target symbol created as a method
  r> dup cell+ >r @                     \ get extension address of template packet
  new-method-packet                     \ and make new one
  'latest(s) @(m) over set-methods-c/v  \ copy C/V info from symbol to new packet
  'latest(s) @(m) fwd-ref+ !(s)         \ set the extension packet address into the symbol
;

((
: lay-method            \ extension -- ; lay method whose symbol is at this address
  @(s) value+ @(s) ,c(t)
;
))

variable OperatorType(t)        \ used at compile time for prefix operator
                                \ 0 = default
                                \ 1 = store
                                \ 2 = addr

: sel-method            \ symbol1 -- sym-method ; get symbol of required method
  fwd-ref+ @(s) cell+ cell+ cell+               \ address of extension packet first method
  OperatorType(t) @off cell * +                 \ indexed by method selector
  @(s)                                          \ return symbol
;

: method0@              \ symbol -- method-sym
  fwd-ref+ @(s) [ 3 cells ] literal + @(s)  ;

: method1@              \ symbol -- method-sym
  fwd-ref+ @(s) [ 4 cells ] literal + @(s)  ;

: method2@              \ symbol -- method-sym
  fwd-ref+ @(s) [ 5 cells ] literal + @(s)  ;


\ Compile-Value ?Target-Compile ?Target-Interpret ?Target -- J Lee .. 21 Feb 96

((
: Compile-Value  ( sym_addr -- )
  lay-target? If
    dup value-addr@ c_val@
\    target-sym VAL@ compile-ref  dup value-addr@ ,c(t)
  Endif
  ?b-d If
    dup value-addr@ postpone literal  compile @d(t)   \ build host analogue
  Endif
  drop
;
))

: BadOperator	\ sym operator -- ; SFP067
  cr ." Can't handle operator " . ." for " .SymName err_TargSym throw
;

: Compile-Value  ( sym_addr -- ; SFP067 )
  lay-target? If
    case  [ also system ] OperatorType @ [ previous ]
      0 of  dup value-addr@ c_val@  endof
      1 of  dup value-addr@ c_val!  endof
      2 of  dup value-addr@ general-literal  endof
            BadOperator
    endcase
  Endif
  ?b-d If
    dup value-addr@ postpone literal
    case  [ also system ] OperatorType @ [ previous ]
      0 of  postpone @d(t)  endof	\ build host analogue ; SFP078
      1 of  postpone !d(t)  endof
      2 of  endof
            BadOperator
    endcase
  Endif
  [ also system ] OperatorType off [ previous ]
  drop
;

\ JL004
: Compile-UserVar       \ sym_addr --
  lay-target? If
    dup c_userchild
  Endif
  ?b-d If
    cr ." Can't access USER variables in defining word"  ABORT
  Endif
  drop
;

: compile-method-method \ symbol-addr --
  lay-target? if
    dup compile-ref                     \ primary symbol reference
    dup sel-method compile-ref          \ reference to method
  endif
  ?b-d If
    cr ." Can't access METHOD> words in defining word"  ABORT
  Endif
  drop
;

: Compile-Method  ( sym_addr -- )
  case
    dup method_value?        ?Of  compile-value           Endof
    dup method_UserVar?      ?Of  compile-UserVar         Endof
    dup method_methods?      ?of  compile-method-method   Endof
    cr ." Can't compile: " .SymName err_TargSym throw
  end-case
;

: Compile-C/V	\ symbol -- ; SFP055
  dup c_c/v				\ call into code generator
  ?b-d  if				\ deal with CREATE ... DOES> case
    c/v@ postpone literal
  else
    drop
  endif
;

\ JL025 SFP037, SFP055
: ?Target-Compile  ( sym_addr -- )
  case
    dup method?  ?Of  compile-method  Endof
    dup c/v?     ?Of  compile-c/v     Endof
    dup Field?   ?Of  compile-field   Endof             \ add field offset      \ SFP049
    compile-ref compile-cc
  end-case
;


: Get-Methods-C/V       \ symbol -- n | d
  dup 2C/V?
  if    fwd-ref+ @(s) cell+ 2@(s)
  else  fwd-ref+ @(s) cell+ @(s)
  endif
;

: Interp-Method  ( sym_addr -- )
  case
    dup method_methods? ?of  Get-Methods-C/V   Endof       \ MUST be before C/V
    dup method_value?   ?Of  value-addr@ @d(t)  Endof
    cr ." Can't execute: " .SymName err_TargSym throw
  end-case
;

: ?Target-Interpret  ( sym_addr -- )
  case
    dup voc?     ?Of  is-voc(s)      Endof      \ set voc
    dup method?  ?Of  interp-method  Endof      \ special cases for methods - MUST be before C/V
    dup c/v?     ?Of  c/v@           Endof      \ Get constant value / variable address
    dup 2c/v?    ?Of  2c/v@          Endof      \ Get 2constant value
    dup create?  ?Of  create@        Endof      \ Get create address
    dup Field?   ?Of  interp-field   Endof      \ add field offset              \ SFP049
    cr ." Can't execute: " .SymName err_TargSym throw
  end-case
;

: ?Target  ( -- c/v | nil )
  here find(t)                  \ symbol exists?
  If                            \
    compil?                     \     compiling into target?
    If                          \     y:
      ?target-compile           \        compile reference or literal
    Else                        \     n:
      ?target-interpret         \        simulate execution if possible
    Endif                       \
    r> drop                     \     symbol found so don't bother to process it any more
  Endif
;

: To-Interp  ( ... sym_addr -- )
  case
    dup method_value?  ?Of  value-addr@ !d(t)  Endof
    cr ." Can't TO: " .SymName err_TargSym throw
  end-case
;

: To-Compile-Value  ( sym_addr -- )
  lay-target? If
    dup value-addr@ c_val!
  Endif
  ?b-d If
    dup value-addr@  postpone literal  postpone !d(t)       \ build host analogue ; SFP078
  Endif
  drop
;

\ JL002, JL008

: to-compile-method     \ symbol --
  dup compile-ref                       \ compile reference to basic symbol
  method1@ compile-ref                  \ compile TO method
;

\ JL008, JL012
: To-Compile  ( sym_addr -- )
  case
    dup method_value?       ?Of  to-compile-value           Endof
    dup method_methods?     ?Of  to-compile-method          Endof       \ SFP017
    cr ." Can't TO: " .SymName err_TargSym throw
  end-case
;

: Addr-Compile-Value	\ sym_addr -- ; SFP059
  lay-target? If
    dup value-addr@ c_val
  Endif
  ?b-d If
    dup value-addr@ postpone literal	\ build host analogue
  Endif
  drop
;

: Addr-Compile	\ sym_addr -- ; SFP059
  case
    dup method_value? ?Of  addr-compile-value  Endof
    cr ." Can't ADDR: " .SymName err_TargSym throw
  end-case
;


\ ****************************************
\ Interpage compilation and interpretation
\ ****************************************

: find(p)       \ ^string -- section symbol true | false ; SFP045 no change needed
  [ also sections.voc ]
  section-chain
  begin
    @ ?dup                              \ while sections left to process
   while                                \ -- ^string section
    dup MS-bank @ if                    \ if this section is a page in a bank
      dup MS-symbol @ if                \ and it has a host vocabulary
        2dup MS-symbol @ v-find(t) ?dup \ look for the symbol
        if                              \ -- ^string section symbol +/-1
          >r rot drop r>  exit          \ -- section symbol +/-1
        else
          drop                          \ discard text address
        endif
      endif
    endif
    MS-link
  repeat
  drop  false                           \ discard text address, return 0
  [ previous ]
;

: Page-Compile-Method   \ section symbol --
  cr ." Can't inter-page compile: " .SymName err_TargSym throw
;

: (?Page-Compile)       \ section symbol -- ; compile inter page reference
  case
    dup method?  ?Of  page-compile-method  Endof
    dup c/v?     ?Of  nip                       \ discard section
                      mpe_standard?
                      if
                        dup compile-ref  c/v@
                      else
                        c/v@ dup doliteral,
                      endif
                      ?b-d  if  postpone literal  else  drop  endif
                 Endof
    page-compile-ref
    ?b-d abort" Can't process inter-page reference in defining word"
  end-case
;

: ?Page-Compile \ -- ; check for an interpage reference
  here find(p) ?dup                     \ symbol exists?
  If
    -1 <> abort" Can't process inter-page IMMEDIATE word"
    (?page-compile)
    r> drop                             \ symbol found so exit caller
  Endif
;

: (?Page-Interp)        \ section symbol --
  nip
  case
\    dup voc?     ?Of  is-voc(s)      Endof      \ can't execute vocabulary if page not opened
    dup method?  ?Of  interp-method  Endof      \ special cases for methods - MUST be before C/V
    dup c/v?     ?Of  c/v@           Endof      \ Get constant value / variable address
    dup 2c/v?    ?Of  2c/v@          Endof      \ Get 2constant value
    dup create?  ?Of  create@        Endof      \ Get create address
    cr ." Interpage - can't execute: " .SymName err_TargSym throw
  end-case
;

: ?Page-Interp  \ -- c/v | ; check for an interpage reference
  here find(p)                          \ symbol exists?
  If
    (?Page-Interp)
    r> drop                             \ symbol found so exit caller
  Endif
;

\ SFP068...
16bit? [if]
: +Page(t)	\ addr(t) -- addr(t)+page<<16
  $FFFF and  pageid(t) #16 lshift or
;
[then]

32bit? 64bit? or [if]
: +Page(t)	\ addr(t) -- addr(t)
; immediate
[then]
\ ...SFP068


\ ********************************************************
\ Modifications for EXTEND_COMPILER and EXTEND_INTERPRETER
\ ********************************************************

variable EXTENSION_MODE                 \ non-zero when extending the compiler/interpreter
  0 constant EXTEND_HOST
  1 constant EXTEND_COMPILER
  2 constant EXTEND_INTERPRETER
  3 constant EXTEND_ASSEMBLER

: ?show-lit-value       \ n -- n
  cr ." Found EQU/LIT/CV " here count type ."  of value " dup .dword
;

: ?show-2lit-value       \ n -- n
  cr ." Found 2C/V " here count type ."  of value " 2dup .dword space .dword
;

: extension-#literal	\ xn..x1 n -- ; process literal after COMPILER or INTERPRETER	SFP053
  ?dup if
    0 swap 1- DO
      i roll 1 #literal
      extension_mode @ EXTEND_COMPILER = if
        postpone general-literal
      endif
    -1 +LOOP
  endif
;

: extension-lit		\ n flag -- [n] ; process literal after COMPILER or INTERPRETER	SFP053
  1 <>  state@ 0<> and if      		\ only compile if compiling and not immediate
    1 extension-#literal
  endif
;

: extension-2lit	\ d flag -- [d] ; process literal after COMPILER or INTERPRETER	SFP053
  1 <>  state@ 0<> and if      		\ only compile if compiling and not immediate
    2 extension-#literal
  endif
;

: label-lit?    \ -- ?? flag ; true if label with value
  here 'LABELS(s) @(m) #threads(s)+ v-find(s)
  if  dup resolved?
      if
        @(s) ( ?show-lit-value ) TRUE extension-lit  true	\ SFP053
      else
        drop  false
      endif
  else
      drop  false
  endif
;

: equ-lit?      \ -- ?? flag ; true if equate
  here 'EQUATES(s) @(m) #threads(s)+ v-find(s)
  if
    @(s) ( ?show-lit-value ) TRUE extension-lit  true		\ SFP053
  else
    drop  false
  endif
;

: c/v-lit?      \ -- ?? flag ; true if C/V
  here find(t)_ans dup >r               \ target symbol?
  if
    dup c/v?                            \ constant/variable?
    if
      c/v@ ( ?show-lit-value ) r@ extension-lit  true		\ SFP053
    else
        dup 2c/v?                       \ try for 2CONSTANT
        if
          2c/v@ ( ?show-2lit-value ) r@ extension-2lit  true	\ SFP053
        else
          drop  false
        endif
    endif
  else
    drop  false
  endif
  r> drop
;

((
: method-lit?   \ -- ?? flag ; true if METHOD ; SFP061
  here find(t) if
    dup method? if
      state@ if
        postpone literal
        extension_mode @ EXTEND_COMPILER = if
          postpone compile-method
	else
	  postpone interp-method
	endif
      else
        interp-method
      endif
      true
    else
      drop false
    endif
  else
    false
  endif
;
))

: method-lit?   \ -- ?? flag ; true if METHOD ; SFP061
  here find(t) if
    dup method? if
      state@ if
        postpone literal
        extension_mode @ EXTEND_COMPILER = if
\ SFP067...
	  [ also system ] OperatorType @off
	  ?dup if
	    postpone literal  postpone OperatorType  postpone !
	  endif
	  [ previous ]
\ ...SFP067
          postpone compile-method
	else
	  postpone interp-method
	endif
      else
        interp-method
      endif
      true
    else
      drop false
    endif
  else
    false
  endif
;

: ?exit         \ flag -- ; exit from caller if flag is true
  if  r> drop  endif  ;

\ SFP057...
: extension-lit?	\ -- ?? flag ; true if extension literal processed
  method-lit? ?dup ?exit
  c/v-lit? ?dup ?exit
  equ-lit? ?dup ?exit
  label-lit? ?dup ?exit
  here count isNumber? dup if
\  here number? dup if
    state @
    if  extension-#literal  true  endif
  endif
;

\ ...SFP057
: extension?    \ addr -- ?? flag ; deal with literals in extension mode
  drop                                  \ assume text at here
  extension_mode @ if
    extension-lit?
  else
    false
  endif
;


\ ******************************
\ Cross Interpreter and compiler
\ ******************************

: INTERPRETING  \ i*x -- j*y
  ?INTERPRETER  ?EQUATES  ?LABELS  ?TARGET ?Page-Interp  ?C-C
\  NUMBER
  ?number  #-13 throw
;

: COMPILING     \ i*x -- j*y
  ?COMPILER  ?TARGET  ?Page-Compile  ?EQUATES  ?LABELS
\  NUMBER COMPILE-NUM
  ?number  make-forward
;

: ASSEMBLING    \ i*x -- j*y
  ?ASSEMBLER ?INTERPRETER ?EQUATES ?LABELS
  ?TARGET ?Page-Interp ?C-C
\  NUMBER
  ?number  make-forward
;

\ JL001 -- When referencing target symbols only constants and variables can be found.

\ SFP057 ...
: normal-interpret	\ -- ; interpret in host mode
  here find ?dup if			\ is the token defined?
    0<  state@  and                     \   are we compiling and the token isn't immediate
    If  compile-word  Else  execute  Endif	\     y:  compile  n:  execute ; SFPxxx
\    If  compile,  Else  execute  Endif	\     y:  compile  n:  execute
  Else
    count isNumber? dup ?undef  state@
\    number? dup ?undef  state@
    If  #literal  Else  drop  Endif
  Endif
;

errdef xcerr_can't_cope	" and cannot deal with this"

: extension-interpret	\ -- ; interpret in extension mode
  extension_mode @ EXTEND_COMPILER =	\ if we are extending the compiler
  state@ and if				\ and inside an extension definition
    here ['] extensions v-find ?dup if	\ if its in the extensions vocabulary
      0< if  compile-word  else  execute  endif	\   process it ; SFP078
\      0< if  compile,  else  execute  endif	\   process it
      exit
    endif
    ['] compiler v-find ?dup if		\ if its in the compiler vocabulary
      0< if  compile-word  else  execute  endif	\   process it ; SFP078
\      0< if  compile,  else  execute  endif	\   process it
      exit
    endif
    drop  extension-lit? ?exit		\ process magic literals (and numbers)
    here find(t)_ans if			\ look for a target definition
\ SFP065...
\      1 #literal  postpone compile-ref	\  that will be compiled later
      dup 1 #literal			\ compile symbol address
      case
        dup method? ?Of  drop  postpone compile-method  Endof
        dup c/v?    ?Of  drop  postpone compile-c/v     Endof
        dup Field?  ?Of  drop  postpone compile-field   Endof	\ add field offset      \ SFP049
          postpone compile-ref
      endcase
\ ...SFP065
      exit
    endif
    cr ." Extending compiler with " count type
    cr xcerr_can't_cope xc-error
    abort
  endif

\ SFP062...
  extension_mode @ EXTEND_INTERPRETER =	\ if we are extending the interpreter
  state@ and if				\ and inside an extension definition
    here ['] extensions v-find ?dup if	\ if its in the extensions vocabulary
      0< if  compile-word  else  execute  endif	\   process it ; SFP078
\      0< if  compile,  else  execute  endif	\   process it
      exit
    endif
    ['] interpreter v-find ?dup if	\ if its in the interpreter vocabulary
      0< if  compile-word  else  execute  endif	\   process it ; SFP078
\      0< if  compile,  else  execute  endif	\   process it
      exit
    endif
    drop  extension-lit? ?exit		\ process magic literals (and numbers)
    here find(t)_ans if			\ look for a target definition
        dup voc?			\   that will be interpreted later
        if  1 #literal  postpone is-voc(s)  ( cr ." got VOC" .s ) exit  endif
        dup Field?
        if  1 #literal  postpone interp-field  ( cr ." got FIELD" .s ) exit  endif
	drop
    else
      drop
    endif
  endif
\ ...SFP062

  here find ?dup if			\ is the token defined?
    0<  state@  and                     \   are we compiling and the token isn't immediate
    If  compile-word  Else  execute  Endif	\     y:  compile  n:  execute ; SFPxxx
\    If  compile,  Else  execute  Endif	\     y:  compile  n:  execute
  Else
    extension? 0=                       \ *** EXTENSIONs *** SFP020
    if  here count isNumber? dup ?undef
\    if  here number? dup ?undef
        state@
        If  #literal  Else  drop  Endif
    endif
  Endif
;

: host-interpret        \ -- ; interpret in host mode
  extension_mode @
  if  extension-interpret  else  normal-interpret  endif
;
\ ...SFP057

: target-interpret      \ -- ; interpret in target mode
\ *sfp* ."  |" here count type ." | "
  compil? if				\ are we compiling for the target?
    compiling				\   compile this token
  Else
    interp? if				\   otherwise, are we interpreting for the target?
      interpreting			\     interpret this token
    Else
      assembling			\       otherwise, assemble this token
    Endif
  Endif
;

variable #lines(cc)     \ -- addr ; no. of lines compiled by INTERPRET(CC)      \ SFP047

: Interpret(cc)	\ -- ; cross compiler's version of INTERPRET
\  cr ." INTERPRET "
  #lines(cc) incr               \ SFP047
  Begin
\    abandon                     \ give the user chance to abort compilation
    bl-word/uc c@ 0=            \ get next input token
    if exit endif               \   but give up if there isn't one
    host-mode @(m) if           \ are we working in host mode?
      host-interpret            \   go away and interpret this on the host
    Else
      target-interpret          \   otherwise interpret it for the target
    Endif
    ?stack                      \ check for stack faults
  Again
;

defer interpret(t)      \ -- ; deferred for Umbilical Forth
  assign interpret(cc) to-do interpret(t)

: XcQuitHook	\ --
\ Cleans up after cross compiler error.
  STATE(T) off(m)
;
assign XcQuitHook to-do QuitHook


\ *********************
\ Vocabulary management
\ *********************

: voc-link,c(t) \ newlink -- ; lay voc-link in ROM
  cbank(t) if                           \ Different if banked
    origin(t) cell(t) + @c(t) 0= if     \  if this is the first voc in the bank
     chere(t) origin(t) cell(t) + !c(t) \    set pointer to the first VOC-LINK field
    endif
    origin(t) @c(t) ,c(t)               \  link is at origin of the section
    origin(t) !c(t)
  else
    Voc-Link(t) @(m) ,c(t)              \ update voc-link(t)
    Voc-Link(t) !(m)                    \ with the CFA
  endif
;

: voc-link,d(t) \ newlink -- ; lay voc-link in RAM
  cbank(t) if                           \ Different if banked
    origin(t) cell(t) + @c(t) 0= if     \  if this is the first voc in the bank
     ihere(t) origin(t) cell(t) + !c(t) \    set pointer to the first VOC-LINK field
    endif
    origin(t) @c(t) ,d(t)               \  link is at origin of the section
    origin(t) !c(t)
  else
    Voc-Link(t) @(m) ,d(t)              \ update voc-link(t)
    Voc-Link(t) !(m)                    \ with the CFA
  endif
;

((
VOCABULARY Now Looks Like (in ANS ROM mode)

ROM ...         				      RAM...
jsr dovoc, here+4,
   +----------------+----------+--------------------+ +----------+-------------+
   | CELL           | CELL     | CELL               | | CELL     | vsize/cell  |
   +----------------+----------+--------------------+ +----------+-------------+
   | Pointer to WID | voc-link | pointer to vocname | | #threads | threads.... |
   +----------------+----------+--------------------| +----------+-------------+

                     ( Points to                      | As created by WORDLIST |
                       previous WID not               ^
                       link )                         |
                                                      A WID points here.
))

((
: Rom-Voc(t)    \ #threads -- ^threads(r) ; make target voc structure in ROM
  mpe_standard? if
    chere(t) 0 >body(t) -               \ PFA to CFA address
    ihere(t) dup >r  ,c(t)              \ lay and save pointer to #threads
    Voc-Link,c(t)                       \ update voc-link(t)
    dup ,d(t)  0 ?Do  0 ,d(t)  Loop     \ zero allotted threads
    r> cell(t) +                        \ retrieve ^threads
  else
    chere(t) cell(t) + ,c(t)            \ support new create structure
    ihere(t) 2 cell(t) * + dup >r ,c(t) \ lay and save pointer to #threads
    r@ Voc-Link,d(t)                    \ update voc-link(t)
    latest(t) ,d(t)                     \ lay pointer to name
    dup ,d(t)  0 ?Do  0 ,d(t)  Loop     \ zero allotted threads
    r> cell(t) +                        \ retrieve ^threads
  endif
;
))
: Rom-WordList(t)	\ #threads -- wid(t) ^threads(t) ; SFP060
  ihere(t)				\ wid = start
  swap dup ,d(t)  0 ?do  0 ,d(t)  loop	\ #threads, 0...
  dup cell(t) +
;

: Rom-Voc(t)    \ -- ^threads(r) ; make target voc structure in ROM ; SFP060
  mpe_standard? if
    chere(t) 0 >body(t) -               \ PFA to CFA address
    chere(t) >r  0 ,c(t)                \ will be WID
    Voc-Link,c(t)                       \ update voc-link(t)
    cur-#threads(t) Rom-WordList(t)	\ build wordlist
    swap r> !c(t)			\ set WID
  else
    chere(t) cell(t) + ,c(t)            \ support new create structure
    chere(t) >r  0 ,c(t)		\ will be wid
    ihere(t) 2 cell(t) * + Voc-Link,d(t) \ update voc-link(t)  *** CARNAL ***
    latest(t) ,d(t)                     \ lay pointer to name
\ cr ." ROM-VOC(T) threads " Vthreads(t) .
    Vthreads(t) Rom-WordList(t)		\ build wordlist ; SFP073
\ cr ." ROM-VOC(T) threads " cur-#threads(t) .
\    cur-#threads(t) Rom-WordList(t)	\ build wordlist
    swap r> !c(t)			\ set WID
  endif
;

((
VOCABULARY Now Looks Like (in RAM mode)

   +----------------+----------+--------------------+----------+-------------+
   | CELL           | CELL     | CELL               | CELL     | vsize/cell  |
   +----------------+----------+--------------------+----------+-------------+
   | Pointer to WID | voc-link | pointer to vocname | #threads | threads.... |
   +----------------+----------+--------------------+----------+-------------+

                     ( Points to                    | As created by WORDLIST |
                       previous WID not             ^
                       link )                       |
                                                    A WID points here.
))
: Ram-WordList(t)	\ #threads -- wid(t) ^threads(t) ; SFP060
  chere(t)				\ wid = start
  swap dup ,c(t)  0 ?do  0 ,c(t)  loop	\ #threads, 0...
  Wid-Link(t) @(m) ,c(t)		\ Update WID-LINK chain
  dup Wid-Link(t) !(m)			\   which points to the WID itself
  dup cell(t) +
;

: Ram-Voc(t)    \ #threads -- ^threads ; make target voc structure in RAM ; SFP060
  chere(t) 3 cell(t) * + dup ,c(t)      \ lay WID  *** CARNAL ***
  voc-link,c(t)                         \ update voc-link(t) with previous WID  \ SJC041
  latest(t) ,c(t)                       \ lay pointer to name
  Vthreads(t) ram-wordlist(t) nip	\ build wordlist ; SFP073
\  cur-#threads(t) ram-wordlist(t) nip	\ build wordlist
;

: VOC(T)        \ -- ^threads ; make target voc in ROM or RAM ; SFP060
  c" VC" chere(t) +Page(t) .log		\ log it to user ; SFP068
  target-sym VOCABULARY compile-run     \ vocabulary run-time-ref
  ?ROM @(m) if				\ #threads for this voc.
    Rom-voc(t)
  else
    ram-voc(t)
  endif
;

: VOC(H)                                \ -- ; build new vocab
  XC-CREATE  4 (make-voc)               \ build new host vocab
  VOC(T)                                \ build target vocab
  'latest(s) @(m) t-vp+ !(s)            \ stash CONTEXT addr
  'latest(s) @(m) status+ mark-voc ;    \ mark symbol as vocab

: WordList(t)	\ -- wid(t) ^threads(t)
  ?rom @(m) if
    #Wid-threads(t) @(m) Rom-WordList(t)
  else
    #Wid-threads(t) @(m) Ram-WordList(t)
  endif
;

hex


\ **************************
\ Page Vocabulary management
\ **************************
((
Pages are handled by building vocabularies in the symbol table.
When a page is referred to, the action is to make the relevant page
active for the memory system, to remove the previously active page in
the bank from the search order, and to make the specified page
vocabulary active.

Page vocabularies are created by PAGE-VOCABULARY <name>, where
<name> is a previously defined page, or by MAKE-PAGE-VOCS, which
creates target vocabularies for all CDATA pages.

The first two cells in a CDATA page are reserved to hold information
about the vocabularies defined in the page.
origin+0        target data address of last vocabulary defined in page
                MPE standard: XT of voc
                ANS standard: CREATE address (ROM if ROM/RAM)
origin+cell     voc-link field of first vocabulary defined in page

See also PAGES in SECTIONS.FTH
))

: ?no-such-page \ flag -- ; error handler
  0= abort" No such page defined"
;

variable pv-pageid      \ -- addr ; kluge to hold pageid of page
variable pv-origin      \ -- addr ; kluge to hold origin of page

: page-voc(t)   \ -- ^threads ; build new page vocab in target ; SFP060
  heads? if				\ only build it if heads enabled
    c" PV" chere(t) +Page(t) .log	\ log it to user ; SFP068
    target-sym PAGE-VOCABULARY compile-run \ vocabulary run-time-ref
    ?ROM @(m) if			\ #threads for this voc.
      Rom-voc(t)
    else
      ram-voc(t)
    endif
    pv-pageid @ ,c(t)                   \ lay pageid of required page
    pv-origin @ ,c(t)                   \ lay origin of required page
  else
    0                                   \ no heads, ^threads=0
  endif
;

: page-voc(h)   \ -- symbol ; build new vocab in symbol table
  (host-create)  0 ,(s)  0 ,(s)         \ build unresolved host symbol
  #16 (make-voc)                        \ host vocabulary with 16 threads
  last'(s)@
  dup status+ dup mark-voc mark-pagevoc \ mark symbol as vocab and page
;

: (MakePageVoc) \ "<name>" -- symbol ; make new host vocab, name in text i/p
  get-token drop  page-voc(h)           \ put string at HERE
;
assign (MakePageVoc) to-do MakePageVoc


\ --------------------------------------
\ DIRECTIVES for the cross compiler user
\ --------------------------------------

(( Can't handle required page IDs and origins
: page-vocabulary       \ origin page-id -- ; PAGE-VOCABULARY <name> ; makes a named page in target
  pv-pageid !  pv-origin !              \ save page data
  ?0-even
  bl-word/uc find(t) ?no-such-page      \ check that page exists
  dup pagevoc? ?no-such-page            \ host page and vocabulary must exist
  xc-create                             \ resolve symbol
  Page-voc(t)                           \ make target
  swap t-vp+ !(s)                       \ put address of target voc in host voc
;
))

: Make-Page-Vocs        \ -- ; MAKE-PAGE-VOCS ; creates all required target vocs        \ SFP045 no change needed
  [ also sections.voc ]
  section-chain
  begin
    @ ?dup                              \ while sections left to process
   while                                \ -- section
    dup MS-bank @ if                    \ if this section is a page in a bank
      dup MS-symbol @ t-vp+ @(s) 0=     \ and there is no target vocab yet
      heads? and if			\ and heads are enabled
        dup MS-pageid @ pv-pageid !     \ stash pageid for vocabulary construction
        dup MS-low @ pv-origin !        \ stash page start for vocabulary construction
        dup body> >name                 \ get page name
        count $1F and here place        \ copy it to HERE
        xc-create                       \ resolve symbol
        Page-voc(t)                     \ make target
        over MS-symbol @ t-vp+ !(s)     \ put address of target voc in host voc
      endif
    endif
    MS-link
  repeat
  [ previous ]
;


\ *********************
\ Defining word support
\ *********************

\ *jl* 8/11/95 Fix up child word so that DOCLASS has a data section pointer
\  *jl* 2 April 96 - added alignment for initialised data section
\ *sfp* jan 97 converted to use patch action like a normal host Forth

: Create(cc)    \ -- ; simulates normal target create ; SFP019
  ?0-even  bl-word-up xc-create         \ build symbol/header
  chere(t)                              \ will be xt
  c_create(cc)                          \ returns address
  c" CR" rot +Page(t) .log		\ log xt to user ; SFP068
  make-create-data-packet
  'latest(s) @(m) status+ mark-data     \ mark as a code symbol *** but WHY? OTA? ***
;

: Does>(cc)     \ -- ; simulates normal target DOES> ; symbol of defining word inline
  r> dup cell+ >r @ dw-value+ @(s)      \ get value of child action address for patching
  'latest(s) @(m) value+ @(s)           \ CFA to be patched
  patch-child
;

: Is-Action-Of  \ addr -- ; here is-action-of <name>
  postpone target-sym  resolve-def-word
;


\ ************************
\ Miscellaneous Primitives
\ ************************

: ([)   STATE(T) off(m)  ;

: (])   1 STATE(T) !(m)  ;

: ([COMPILE])
  BL-WORD/UC FIND(T)                    \ if symbol exists
  IF  compile-ref  ?B-D                 \ compile reference to it
    IF  ?IN-ROOT compile-word  ENDIF	\ SFP078
\    IF  ?IN-ROOT compile,  ENDIF
  ELSE
    here $forward-sym compile-ref       \ make new symbol and compile reference to it SFP023
  ENDIF
;

\ SFP054...
: M",D(T)	\ "text" -- ; lay down string
  [char] " word $expandmacros $,D(T)
;

: M",C(T)	\ "text" -- ; lay down string
  [char] " word $expandmacros $,C(T)
;
\ ...SFP054

: '(T)          \ -- cfa ; in Forth-83 ' is not immediate
  BL-WORD/UC FIND(T) ?undef             \ must be defined
  DUP resolved? ?undef                  \ error if forward ref
  @(s)  ;

: ['(T)]        \ -- ; lay XT of target symbol as a literal ; rewritten SFP023
  bl-word/uc find(t)_ans 0=             \ if symbol does not exist
  if  $forward-sym  endif               \ make forward reference
  dup doliteralcfa,  @(s) ?bd-literal   \ and lay code *** fwd ref in B-D ***
;

: words(sv)     \ voc(s) -- ; display symbol names in the voc
  context(s) @(m)  swap is-voc(s)       \ set new context
  words(s)  cr                          \ show names
  is-voc(s)  ;                          \ restore context



\ ****************************************
\ ($FROM) - performs action of $FROM in XC
\ ****************************************

decimal

: ?show-new-file(cc)  (  --  )
  [ also system ] bVerboseInclude? [ previous ]
  from? and if
    ?log @(m) if
      pcr pcr .SourceFile  pcr
    else
      pcr ( ." Source: " ) .CurrTextFile
    endif
  endif
;

: ?show-resume-file(cc)  (  --  )
  [ also system ] bVerboseInclude? [ previous ]
  from? and  ?log @(m) 0<> and
  if
    out @ if  pcr  endif
    ." resuming from " .SourceFile pcr                                   \ ***JL032***
  endif
;

: .size(t)	\ cstart istart ustart -- ; SFP056
  uhere(t) swap - -rot			\ generate sizes
  ihere(t) swap - swap
  chere(t) swap -			\ -- usize isize csize
  3dup or or if				\ if anything generated
    out @ #30 >
    if  pcr  endif
    base @ >r  decimal
    #32 >pos  ." bytes: "
    . ." Cdata, "
    . ." Idata, "
    . ." Udata"
    r> base !
  else
    2drop drop
  endif
;

defer sfileStartHook
  assign chere(t) to-do sfileStartHook
defer sfileEndHook
  assign drop to-do sfileEndHook

\ : ((include-file))      \ --
\ \ The guts of the include system
\   begin
\     refill  debug1 @
\     if  source type cr  then
\   while
\     LinesCompiled incr
\     interpret
\   repeat
\ ;

also system

: ?markStartOfSource(t)	\ -- ; SFP077
  'SourceFile @ if
    'SourceFile @ -1 <> if
      here(s) 'SourceFile @ SFSTRUCT.StartHERE !
      -1 'SourceFile @ SFSTRUCT.LastHERE !
    then
  then
;

: ?markEndOfSource(t)	\ -- ; SFP077
\ Set HERE(S) as end of source file if structure is valid
  'SourceFile @ if
    'SourceFile @ -1 <> if
      here(s) 'SourceFile @ SFSTRUCT.LastHERE !
    then
  then
;

: xc-include-file	\ ^SFSTRUCT|-1 file-id -- ior
\ The file is already open. The file is not closed afterwards.
  cc-level @ >r  cc-level off		\ prepare cond. comp. check ; SFP077
  save-input n>r  0 line# !
  to source-id  'SourceFile !
  ?markStartOfSource(t)			\ SFP075
  FILETIBSZ allocate if
    drop  err_OutOfMemory
  else
    0 to-source
    ['] ((include-file)) catch dup if	\ SFP074
      IncDir @ -> CurrDir  .throw  -1	\ SFP074
    endif				\ SFP074
    source drop free drop
  then
  ?markEndOfSource(t)			\ SFP075
  nr> restore-input drop
  dup 0= if
    cc-level @				\ check cond. comp. level ; SFP077
    if  drop -424  then
  then
  r> cc-level !				\ restore cond. comp. level ; SFP077
;

: xc-included	\ c-addr u --
\ *G Include source code from a file whose name is given by *\i{c-addr/u}.
  uhere(t) >r  ihere(t) >r  chere(t) >r	\ SFP056
  currsourcefile# @ >r                  \ save current sourcefile no.
  #sourcefiles incr                     \ count number of source files
  #sourcefiles @ currsourcefile# !      \ and set it as the current one

  EmptyIdle
  ResolveIncludeFileName
  bVerboseInclude?
  if  cr ( ." Including " ) 2dup type  then
  AddSourceFile -rot			\ -- ^SFSTRUCT c-addr u
  2dup r/o VF-Open-File #-258 ?throw	\ -- ^SFSTRUCT c-addr u fid ; SFP074
  -rot  ++IncDir			\ -- ^SFSTRUCT fid ; SFP074
  dup >r xc-include-file
  r> close-file drop
  --IncDir				\ SFP074
  throw
  base @ -> SbBase
  depth -> SbDepth
  context @ -> sbContext
  current @ -> sbCurrent

  r> currsourcefile# !                  \ restore sourcefile no.
  r> r> r> .size(t)			\ show code size

  abandon				\ check for user abort
;
previous

