\ rebootCM0.fth - Reboots Nuvoton NUC1xx CPUs

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20110705 MPE001 Updated from LPC17xx version.
))

decimal

\ ==========
\ *! rebootcm0
\ *T Rebooting the CPU
\ ==========
\ *P The word *\fo{REBOOT} permits a system to be reset by
\ ** disabling all interrupts and writing to the AIRCR system
\ ** register. The degree of *\b{chip} reset is implementation
\ ** defined. In most cases, a reboot by setting the watchdog
\ ** is more complete, and hence more reliable.

\ *P If you are unlucky you willl just have to press the board's
\ ** reset button.

: reboot	\ --
\ *G Reboots the CPU by activating the system reset request bit.
  di
  $05FA:0004 _SCS scsAIRCR + !		\ set system reset request bit 2
  [asm  DSB # $0F  asm]
  begin again				\ wait for reset
;


\ ======
\ *> ###
\ ======

decimal

