\ RebootSTM32.fth - Reboots STM32 CPUs

((
Copyright (c) 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal

\ ==========
\ *! rebootstm32
\ *T Rebooting the CPU
\ ==========
\ *P The word *\fo{REBOOT} permits the system to be reset by
\ ** disabling all interrupts and activating the watchdog.

: reboot	\ --
\ *G Reboots the CPU by activating the watchdog.
  di
  bit0 _RCC rccCSR + or!		\ enable LSI oscillator
  $CCCC _IWDG iwdgKR + !		\ start watchdog
  begin again				\ wait for reset
;


\ ======
\ *> ###
\ ======

decimal

