#! /bin/bash
# Linux shell script to compile the Olimex 1766 code
bindir=/usr/bin

if [ -e $bindir/xArmCortexStamp ]; then
  echo "Using STAMP compiler"
  xArmCortexStamp include STM32F103eval.ctl
  exit
fi

if [ -e $bindir/xArmCortexDev ]; then
  echo "Using DEV compiler"
  xArmCortexDev include STM32F103eval.ctl
  exit
fi

echo "Compiler not found"
exit 1
