\
\ Copyright (c) 2012-2014
\ Synics AG
\
\ tel: +41 (0)44 840 40 60
\ net: info@synics.ch
\ web: www.synics.ch
\

\ ---------- general background task -------------

decimal

 990 equ OFF_TIME            \ 1sec heart beat 99% off, 1% on
  10 equ ON_TIME

((
: (do_wdg) \ --   ; invers watchdog signal
  OBJ_WDOG dup get 0= swap put
;
))

10 value MAX_CYCLIC
variable cyclic_descriptor
\ *G This contains the pointer to the function list

variable life_timer

50 equ BACKGROUND_START_DElAY

task background_task

: start_background  \ -- ;
  background_task start:
  decimal console dup opvec ! ipvec ! \ ----- microSD ------------
\  CAN1 can_vector !
  1 2 3 0 sp@ >r  \ use first value as blip flip-flop
  BACKGROUND_START_DElAY ms
  ticks life_timer !
  init_downtimers
  MAX_CYCLIC cyclic_descriptor init_functlist    \ init dynamic fucntion list
\  .internal_T cr
  begin
    pause
    ticks life_timer @ - 0> if
      5 0 do
        TEST_PIN setPin     \ speed control marker
        TEST_PIN clrPin
      loop
      0= dup if
\        BLIP_LED setPin
        ON_TIME
      else
\        BLIP_LED clrPin
        OFF_TIME
      then
      life_timer +!
    then
    update_timers
\    (do_wdg)
    cyclic_descriptor exec_functlist
    sp@ r@ <> if
      ." Stack diff in " self .task sp@ r@ swap - cell / . cr
      r@ sp!
    then
  again
;

' start_background AtCold

