\ AT29LV1024.FTH - Atmel 64k*16 Flash driver

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

))


$1000000 constant flashbase	\ -- addr ; base of flash memory

internal
chere equ fopen-start
: sector29LV1024	\ src dest -- flag ; program 128 word (256 byte) sector
  $AAAA [ flashbase $5555 2* + ] literal w!
  $5555 [ flashbase $2AAA 2* + ] literal w!
  $A0A0 [ flashbase $5555 2* + ] literal w!
  [asm
\ copy 128 words = 256 bytes
    ldr     r0, [ psp ]			\ src=r0, dest=tos, r2=len
    mov     r2, # #128
l: s29-1
    ldrh    r1, [ r0 ], # 2
    strh    r1, [ tos ], # 2
    sub .s  r2, r2, # 1
    b .ne   s29-1
\ wait 150 us min
    mov     r2, # #16384
l: s29-2
    sub .s  r2, r2, # 1
    b .ne   s29-2
    str     r0, [ psp ]
  asm]
  swap 2- w@  swap 2-			\ -- w last
  #100000 >r				\ wait for prog or fail
  begin
    r> 1- >r
    2dup w@ =				\ leave if same
    r@ 0= or 
  until
  r> drop
  w@ <>					\ fail if different
;
chere fopen-start - equ fcode-size
external

fcode-size buffer: fcodeBuffer

: prog29LV1024	\ src dest len --
  fopen-start fcodebuffer fcode-size cmove	\ code to RAM
  0 ?do					\ -- src dest
    di
    2dup fcodeBuffer execute
    ei
    if  [char] E else [char] . then emit
    #256 + swap #256 + swap
  #256 +loop
  2drop
;

#256 buffer: testbuff

