
[undefined] RegisterPressure? [if]
1 equ RegisterPressure?
[then]

RegisterPressure? [if]
: ut*		\ ud1 u2 -- ut3
\ unsigned triple result
  dup >r  swap >r			\ u1l u2 -- ; R: -- u2 u1h
  um*					\ -- d(u1l*u2)
  r> r> um*				\ -- d(u1l*u2) d(u1h*u2)
  >r  0 tuck d+  r> +
;
[else]
: ut*		\ d1 n1 -- t
\ unsigned triple result
  rot over um*				\ -- d1h n1 t0lm
  2swap um*				\ -- t0lm t1mh
  rot rot				\ -- t0l t1h t0m t1m
  0 tuck d+				\ -- t0l t1h tzm carry
  rot +					\ -- tl tm th
;
[then]

: ut/		\ ut1 u2 -- udquot
  dup >r  um/mod -rot  r> um/mod nip swap
;

: M*/		\ d1 n2 +n3 -- d4
  2 pick  2 pick xor  over xor >r	\ -- d1 n2 ; R: sign(d1*n2/n3)
  dup >r				\ -- d1 n2 ; R: sign(d1*n2/n3) n3
  abs -rot dabs rot ut*			\ -- ut ; R: n3 sign(d1*n2/n3) n3
  r> abs ut/				\ -- ud4 ; R: n3 sign(d1*n2/n3)
  r> 0<
  if  dnegate  endif
;

\ DUP 2OVER XOR >R DROP  >R >R
\   DABS  R> ABS UT*  R> UT/  R> 0< IF  DNEGATE  THEN ;

[undefined] m*/ [if]
: m*/		\ d1 n2 +n3 -- dquot
\ *G The result dquot=(d1*n2)/n3. The intermediate value d1*n2
\ ** is triple-precision.
\ ** In ANS Forth n3 can only be a positive signed number.
    >r					\ -- d1 n2 ; R: -- n3
    s>d >r abs				\ -- d1 |n2| ; R: -- n3 sign(n2)
    -rot				\ -- |n2| d1 ; R: -- n3 sign(n2)
    s>d r> xor				\ -- |n2| d1 d1h*sign(n2) ; R: -- n3
    r> swap >r >r			\ -- |n2| d1 ; R: -- d1h*sign(n2) n3
    dabs rot				\ -- |d1| |n2| ; R: -- d1h*sign(n2) n3
    tuck um* 2swap um*			\ -- d1h*n2 d1l*n2 ; R: -- d1h*sign(n2) n3
    swap >r 0 d+ r> -rot		\ -- t ; R: -- d1h*sign(n2) n3
    r@ um/mod -rot r> um/mod nip swap
    r> IF dnegate THEN
;
[then]

: UT*		\ ud u -- ut
  DUP >R  SWAP >R  UM*  R> R> UM* >R
  0 SWAP  0 D+  R> +
;

: UT/		\ ut u -- ud
  DUP >R UM/MOD  R> SWAP >R
  UM/MOD  SWAP DROP R>
;

: UM*/		\ ud1 u1 u2 -- ud2
  >R UT*  R> UT/
;

