#! /bin/bash
# Linux shell script to compile the USB Stamp
bindir=/usr/bin

if [ -e $bindir/xArmStamp ]; then
  echo "Using STAMP compiler"
  xArmStamp include USBstamp.ctl
  exit
fi

if [ -e $bindir/xArmDev ]; then
  echo "Using DEV compiler"
  xArmDev include USBstamp.ctl
  exit
fi

echo "Compiler not found"
exit 1
