\ FlashTables.fth

((
Copyright (c) 2008, 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20100503 MPE002 LPC24xx update.
20081008 MPE001 LPC23xx first release.
))

decimal


\ ======
\ *! flashtables
\ *T Philips LPC2xxx Flash sector tables
\ ======

decimal
\ *P Sector tables contain the number of sectors and starting offset
\ ** of each sector, plus a dummy start address which enables
\ ** the size of the last sector to be calculated.
\ ** The boot block sector is *\b{not} included in the table.

$0000:0000 equ FlashBase	\ -- addr ; base address of Flash

#2300 LPCtype =
#2388 LPCtype = or
#2400 LPCtype = or
#2468 LPCtype = or
[if]
create sectab	\ -- addr
\ *G Generic LPC23xx/24xx sector table for CPUs with up to 512k Flash.
\ ** Note that because of the IAP/ISP code, 504 kb is available
\ ** for applications.
  #28 ,					\ number of usable sectors
  $00000000 ,  $00001000 ,  $00002000 ,  $00003000 ,
  $00004000 ,  $00005000 ,  $00006000 ,  $00007000 ,
  $00008000 ,  $00010000 ,  $00018000 ,  $00020000 ,
  $00028000 ,  $00030000 ,  $00038000 ,  $00040000 ,
  $00048000 ,  $00050000 ,  $00058000 ,  $00060000 ,
  $00068000 ,  $00070000 ,  $00078000 ,  $00079000 ,
  $0007A000 ,  $0007B000 ,  $0007C000 ,  $0007D000 ,
  $0007E000 ,		\ dummy
[then]


\ ======
\ *> ###
\ ======

