\ Reboot9200.fth - Reboots Atmel AT91RM9200 CPUs

((
Copyright (c) 2006
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal

\ ==========
\ *! reboot9200
\ *T Rebooting the CPU
\ ==========
\ *P The word *\fo{REBOOT} permits the system to be reset by disabling
\ ** all interrupts and activating the watchdog. This file should
\ ** be compiled before *\i{INTARM3}.FTH.

: reboot	\ --
\ *G Reboots the CPU by activating the watchdog.
  di dfi  $10001 _ST ST_WDMR + !	\ start watchdog
  begin again				\ wait for reset
;


\ ======
\ *> ###
\ ======

decimal

