#! /bin/bash
echo ******************************
echo Date changed in COMMONTGT.DGS?
echo ******************************
rm ###.html

# *** generate output with DocGen
vfx64  include commontgt.dgs
rm textitle.html

# *** generate PDF manual
echo Error log will be in manual.log
rm manual.log
# *** make PDF and clean up
# *** pdftex is run three times. The first two runs generate the
# *** index twice using texindex. This ensures that the page
# *** numbers are correct in the index file. The third run is
# *** for the final manual using the index file from the second
# *** run.
# rm TEXFILES/*
rm manual.off
rm manual.fns
# cp *.tex TEXFILES/
# PDFTEXOPTS=-interaction=batchmode
PDFTEXOPTS=

pdftex $PDFTEXOPTS manual.tex
texindex manual.??
pdftex $PDFTEXOPTS manual.tex
texindex manual.??
pdftex $PDFTEXOPTS manual.tex

# *** clean up
mv manual.pdf CommonCode.pdf
cat manual.off > CommonCode.vix
cat manual.fns >> CommonCode.vix

mv manual.log commoncode.log
rm manual.*
rm *.tex
mv commoncode.log manual.log

echo Manual is in file CommonCode.pdf
rm *.tex
rm *.toc
