\ Target text file words for use with XSHELL v2/3 and AIDE

((
Copyright (c) 1991..2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

20020917 SFP003 Refactored to reduce size
20000530 SFP002 Converted to v6.1 targets
19990509 SFP001 Rewritten for AIDE/PowerTerm.
                Removed support for USE
First Release: 29/04/91

Changes:        See RELEASE.TXT for full details
))


\ ****************************************************
\ end-load file-error $from-file from-file get include
\ ****************************************************

decimal

: end-load      \ -- ; switch back to keyboard input
\ This word is automatically performed at the end of a download
\ It re-assigns the error handlers, and tidies up the comms
  xon/xoff off                  	\ turn off handshaking
  echoing on                    	\ turn echoing back on
  assign (error) to-do error    	\ normal error handler again
;

internal
: file-error    \ n --
  ^e ser-emit                           \ trigger host error
  CR ." Error # " .  SPACE here $. CR   \ show error
  ack ser-emit                          \ finish host error
  Wait-Ack/Nack Disk-error !            \ get status respons
  xon ser-emit                          \ initiate end-load
  end-load                              \ clean up
  xoff ser-emit                         \ finish comms protocol
  abort                                 \ abort into system
;

: $include	\ $addr -- ; compile host file, counted string
  ^f send$                      	\ send file name
  -1 send-block#                   	\ send last-p# - legacy
  1 send-block#                   	\ send first-p# - legacy
  synch-to-host                 	\ synchronise
  echoing off                   	\ not echoing
  xon/xoff on                   	\ initiate handshaking
  assign file-error to-do error 	\ new error handler
;

external

: include       \ "<filename>" -- ; load file from host
  bl word                               \ get file name
  dup count upper                       \ convert to upper case
  $include				\ compile from file
;

: get           \ "<filename>" -- ; synonym for INCLUDE
  include
;

decimal

