
\ This program comprises a very simple multi-tasking example.  It only
\ exercises the basic word set and does *not* send messages or invoke
\ the event handling mechanism.  The program can be included into the
\ control file or down-loaded directly to the target over the serial link.

decimal

1  constant leds-task
7  constant last-task

: leds-task-word
  led-init
  begin
    led-on
    #30 0 do pause loop
    led-off
    #100 wait
  again
;

: .tasknumber s>d decimal  <# # # #> type ;
: .taskvalue  s>d hex <# # # # # #> type ;

: nums-task-word
  hex
  0
  begin
    self .tasknumber [char] = emit
    1+ dup .taskvalue bl emit
    self #10 * wait
  again
;

: simpmult
  assign leds-task-word leds-task to-task
  last-task 1+  leds-task 1+
  ?do
    assign nums-task-word i to-task
  loop
  leds-task activate
  last-task 1+  leds-task  ?do  i activate  loop
  0
  begin
    1+
    cr cr ." Loop " dup u. cr cr
    #1000 wait
  again
;
: run simpmult ;

