\ Display ARM floating point immediates

((
FP const: abcdefgh

Expand to:
  aBbbbbbc defgh000 00000000 00000000

20200714 SFP002 64 bit conversion
))

decimal

cellbits #32 = [if]
include %VfxPath%\lib\x86\ndp387
[then]
cellbits #64 = [if]
include %VfxPath%\lib\x64\FPSSE64S
[then]

: b>Bbbbbb	\ b -- pattern
  if  $3E00:0000  else  $4000:0000 endif
;

: mfi>val	\ mfi -- val
  0					\ -- mfi val
  over $80 and 24 lshift or
  over $40 and b>Bbbbbb or
  over $3F and 19 lshift or
  nip
[ cellbits 64 = ] [if]
  $FFFF:FFFF and
[then]
;

variable transfer	\ -- addr

: showMFI	\ --
  256 0 do
    i mfi>val transfer !
    cr i .byte space
    transfer @ .dword space
    transfer SF@ F.
  loop
;