\ HTML index and main menu

\ ========
\ *^ index
\ ========
\ by using '*^', index.html does not acquire the default HTML header.
\ *W <!DOCTYPE html>
\ *W <html lang="en">
\ *W   <head>
\ *W     <meta charset="utf-8">
\ *W     <meta http-equiv="X-UA-Compatible" content="IE=edge">
\ *W     <meta name="viewport" content="width=device-width, initial-scale=1">
\ *W     <title>MPE Forth 7 ARM Cortex User Manual</title>
\ *W
\ *W     <!-- Bootstrap core CSS -->
\ *W     <link href="bootstrap.min.css" rel="stylesheet">
\ *W     <script src="script.js"></script>
\ *W     <style type="text/css">
\ *W        #left_frame {
\ *W             width: 30%;
\ *W 	         height: 100vh;
\ *W 	         border: 0px;
\ *W        }
\ *W        #right_frame {
\ *W             width: 70%;
\ *W 	         height: 100vh;
\ *W 	         border: 0px;
\ *W        }
\ *W        #left_frame,
\ *W        #right_frame { float: left; }
\ *W
\ *W     </style>
\ *W   </head>
\ *W
\ *W   <body>
\ *W
\ *W     <iframe id="left_frame" src="mainmenu.html" name="menu"></iframe>
\ *W     <iframe id="right_frame" src="titlepg.html" name="main"></iframe>
\ *W
\ *W   </body>
\ *W </html>
\ ======
\ *> ###
\ ======

\ ===========
\ *! mainmenu
\ ===========
\ *W <A target="main" HREF="titlepg.html">Home</A><BR>
\ *W <A target="main" HREF="license.html">License</A><BR>
\ *W <A target="main" HREF="intro.html">Introduction</A><BR>
\ *W <A target="main" HREF="notation.html">Notation</A><BR>
\ *W <A target="main" HREF="xoptcortex.html">ARM Cortex VFX Code generator</A><BR>
\ *W <A target="main" HREF="xasmcortex.html">ARM Cortex Assembler</A><BR>
\ *W <A target="main" HREF="cortexints.html">Cortex Interrupts</A><BR>
\ *W <A target="main" HREF="armints.html">ARM Interrupts</A><BR>
\ *W <A target="main" HREF="sharedc.html">Calling routines in othe rlanguages</A><BR>
\ *W <A target="main" HREF="jlink.html">Segger J-Link integration</A><BR>
\ *W <A target="main" HREF="svdconv.html">SVD file converter</A><BR>
\ *W <A target="main" HREF="furtherinfo.html">Further Information</A><BR>
\ ======
\ *> ###
\ ======


\ Texinfo files
\ =========
\ *! manual
\ =========
\ *R \input texinfo
\ *R @setfilename            armman.info
\ \ *R @setcontentsaftertitlepage
\ *R @afourpaper
\ *R @settitle               Forth 7 ARM Cortex Cross Compiler
\ *R @setchapternewpage      odd
\ *R @paragraphindent        0
\ *R @exampleindent          0
\ *R @finalout

\ *R @include titlepg
\ *R @contents
\ *R @include license
\ *R @include intro
\ *R @include notation
\ *R @include xoptcortex
\ *R @include xasmcortex
\ *R @include cortexints
\ *R @include armints
\ *R @include sharedc
\ *R @include jlink
\ *R @include svdconv
\ *R @include furtherinfo

\ *R @unnumbered{Index}
\ *R @*
\ *R @findex
\ *R @printindex fn

\ *R @unnumbered{List of Tables}
\ *R @listoffloats Table
\ \ *R @unnumbered{List of Figures}
\ \ *R @listoffloats Figure

\ *R @bye

\ ======
\ *> ###
\ ======

