@echo off
rem *** Builds Forth 7 for ARM Cortex manual

rem *** define VFX Forth host
set VfxHost=X:\Products\VfxCommunity\Sources\Images\VfxForth_x86_win.exe

rem *** build HTML and TeX files
del *.html
del *.tex
%VfxHost%  include MakeCortex.dgs

rem *** make PDF and clean up
rem copy *.tex texfiles
xcopy /Y /Q ..\Images\*.pdf .
rem texify -p manual.tex
rem texify -p manual.tex
pdftex manual.tex
texindex manual.fn
pdftex manual.tex
texindex manual.fn
pdftex manual.tex

ren manual.pdf CortexMan.pdf
ren manual.tex CortexMan.tex
ren manual.log CortexMan.log
ren manual.fn  CortexMan.fn
ren manual.fns CortexMan.fns
del manual.*
ren CortexMan.pdf manual.pdf
ren CortexMan.tex manual.tex
ren CortexMan.log manual.log
ren CortexMan.fn  manual.fn
ren CortexMan.fns manual.fns
rem *** delete trivia and TeX files
rem del ###.html
del *.tex

rem *** save last copy
xcopy /Y /Q manual.pdf ..\PDFs\ArmCortexMan.pdf
xcopy /Y /Q manual.fns ..\PDFs\ArmCortexMan.vix
del ..\xARM.htm\*.*  /Q
xcopy /Y /Q *.html     ..\xArmCortex.htm\*.html
xcopy /Y /Q *.css      ..\xArmCortex.htm\*.css
del *.html /Q
xcopy ..\Images\*.jpg  ..\xArmCortex.htm\*.jpg  /Y /Q
xcopy ..\Images\*.png  ..\xArmCortex.htm\*.png  /Y /Q
xcopy ..\Images\*.gif  ..\xArmCortex.htm\*.gif  /Y /Q

rem *** all done
echo Read and then delete MANUAL.LOG.
pause
:xxx
