\ NOPTHEAD.FTH - headers for target optimiser

((
        Copyright (c) 2000
        MicroProcessor Engineering Ltd.
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 (0)23 80 631441
        net: mpe@mpeforth.com
             tech-support@mpeforth.com
        web: www.mpeforth.com
))


: NoptHeader(t)	\ -- ; text at HERE
  here DUP C@ WIDTH(T) @(m) MIN ?dup IF
    ?0-even				\ link on even boundary
    thread,				\ lay thread link
    chere(t) last(t) !(m)		\ mark NFA
    OVER C@ $80 OR C,C(T)  0		\ lay count byte
    DO  1+ DUP C@ C,C(T)  LOOP		\ and text
    DROP
    ?force-align			\ align CODE-LEN field
    0 ,c(t)				\ code length/generator
  ELSE
    drop  ?force-align
  ENDIF
  DefnType off				\ for optimising CFAs
;

: NoptImmediate(t)	\ -- ; default version
  $40 'latest(s) @(m) >name(s) set-bit(s)	\ target symbol flag
  width(t) @(m) if			\ if heads on target
    latest(t) $40 toggle-c(t)		\   set target flag
  endif
;

: NOptHeaders	\ -- ; for native code generation
  assign NoptHeader(t) to-do header(t)
  assign NoptImmediate(t) to-do immediate(t)
  #31 width(t) !(m)
;
