\ Required words for cross compiler to initialise symbols.

((
File:   REQUIRED.FTH

        Copyright (c) 1993-2000, 2009

        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: (+44) 2380 631441
        net: mpe@mpeforth.com
Change history
==============
20101015 SFPXxx Added APP-xxx items
20001008 SFP012 Added U/ SM/REM
20000903 SFP011 Added DI EI [I I]
20000726 SFP010 Added WID-LINK
20000102 SFP009 Added / LSHIFT RSHIFT INCR DECR
19990719 SFP008 Added D+ D-
19981215 SFP007 Added COMPILE,
19981119 MSD006 Removed UMBILICAL? from the "required" list.  This was
         MSD006 causing problems when common files were used for umbilical and
         MSD006 and ROM Forths.  Required EQUs are *always* [DEFINED]...
         MSD006 (EQU should really set the "resolved" bit.) The reason why
         MSD006 these two words were made "required" was that we didn't *have*
         MSD006 [DEFINED] et al.  Now, we *do* and hence they don't need to be
         MSD006 required any more.  In fact, I've elected to leave TESTCODE?
         MSD006 as required since that allows the test for its *value* to be
         MSD006 placed anywhere and one can invoke the test code merely by
         MSD006 EQUing TESTCODE? to TRUE.
19981020 MSD005 Added the shift words: 2* 4* 2/ 4/ U2/ U4/
19980928 MSD004 Added required symbols M* and UM* (for the ARM).
19980306 SFP003 Added required symbol *
19980305 SFP002 Added required symbol ROLL
19980303 MSD001 Added the new required EQU TESTCODE? and UMBILICAL?.
))

only forth also c-c definitions
decimal




((
**********************************
I/O Words treated as special cases
**********************************
))
  Required-Symbol CR
  Required-symbol TYPE
  Required-Symbol EMIT
  Required-Symbol PAGE

  Required-Symbol KEY
  Required-Symbol EKEY
  Required-Symbol KEY?

  Required-Symbol DI			\ SFP011
  Required-Symbol EI			\ SFP011
  Required-Symbol [I			\ SFP011
  Required-Symbol I]			\ SFP011


((
*********************
Miscellaneous Symbols
*********************
))

  Required-Symbol 2*                                                            \ MSD005
  Required-Symbol 4*                                                            \ MSD005
  Required-Symbol 2/                                                            \ MSD005
  Required-Symbol 4/                                                            \ MSD005
  Required-Symbol U2/                                                           \ MSD005
  Required-Symbol U4/                                                           \ MSD005
  Required-Symbol ROLL                                                          \ SFP002
  Required-Symbol *                                                             \ SFP003
  Required-Symbol M*                                                            \ MSD004
  Required-Symbol UM*                                                           \ MSD004
  Required-Symbol /			\ SFP009
  Required-Symbol U/			\ SFP012
  Required-Symbol SM/REM		\ SFP012
  Required-Symbol UM/MOD		\ SFP012
  Required-Symbol LSHIFT		\ SFP009
  Required-Symbol RSHIFT		\ SFP009
  Required-Symbol INCR			\ SFP009
  Required-Symbol DECR			\ SFP009

  Required-Symbol @
  Required-Symbol !
  Required-Symbol +!
  Required-symbol +STRING
  Required-Symbol -TRAILING
  Required-Symbol ?BRANCH
  Required-Symbol (;CODE)
  Required-Symbol (ABORT")
  Required-Symbol (EXIT)
  Required-SYmbol (OF)
  Required-Symbol (S")
  Required-Symbol >NUMBER
\  Required-symbol COUNT
  Required-symbol .
  Required-symbol .R
\ JLSTC...
\  Required-Symbol 0
\  Required-Symbol 1
\  Required-Symbol 2
\  Required-Symbol 4
\  Required-Symbol -1
\ ...JLSTC
  Required-Symbol 2@
  Required-Symbol 2!
  Required-symbol ALIGNED
  Required-symbol BINARY
  Required-Symbol BLANK

  Required-Symbol BRANCH

  Required-Symbol C,
  Required-Symbol C!
  Required-Symbol C@
  Required-Symbol C+!

  Required-Symbol W,
  Required-Symbol W!
  Required-Symbol W@
  Required-Symbol W+!

  Required-symbol ABS
  Required-symbol CELL
  Required-symbol CELLS+
  Required-Symbol COMPARE
  Required-Symbol COMPILE
  Required-Symbol COMPILE,
  Required-Symbol COUNT
  Required-symbol BOUNDS
  Required-Symbol DABS
  Required-Symbol DECIMAL
  Required-Symbol DROP
  Required-Symbol ERASE
  Required-Symbol FIND
  Required-Symbol HEX
  Required-Symbol LIT
  Required-symbol MAX
  Required-symbol MIN
  Required-Symbol MOVE
\  Required-Symbol HOLD
\  Required-Symbol KEY
\  Required-Symbol KEY?
  Required-Symbol RESERVE

  Required-Symbol VAL@                  \ value support
  Required-Symbol VAL!
  Required-Symbol VAL

  Required-Symbol LV@                   \ local variables
  Required-Symbol LV!
  Required-Symbol LV
  Required-Symbol MAKELVS
  Required-Symbol RELLVS

  Required-Symbol WORD

  Required-Symbol (.")
  Required-Symbol (C")
  Required-Symbol ",

  Required-Symbol (+LOOP)
  Required-Symbol (DO)
  Required-Symbol (?DO)
  Required-Symbol (LOOP)
  Required-Symbol (TO-DO)

  Required-Symbol CRASH

  Required-Symbol ,
  Required-Symbol HERE
  Required-Symbol ALLOT

  Required-Symbol (METHODS>)

  Required-Symbol PAGE-EXECUTE          \ inter page caller

  Required-Symbol D+			\ SFP008
  Required-Symbol D-			\ SFP008

  Required-Symbol valComp,		\ for VFX Forth
  Required-Symbol (?prefix)		\ to cross compile assembler

  Required-Symbol fsp@
  Required-Symbol fsp!


\ Required defining words ...............          Jon 05/08/88

  Required-Def-Word :
  Required-Def-Word :NONAME
  Required-Def-Word CONSTANT
  Required-Def-Word DOES>
  Required-Def-Word VARIABLE
  Required-Def-Word USER
  Required-Def-Word VOCABULARY
  Required-Def-Word PAGE-VOCABULARY
  Required-Def-Word CREATE
  Required-Def-Word DEFER
  Required-Def-Word VALUE
  Required-Def-Word 2VALUE
  Required-Def-Word 2CONSTANT
  Required-Def-Word LVAR
  Required-Def-Word FIELD


\ Required labels -- J Lee .. 14/4/93

  Required-Label INIT-VOC-LINK
  Required-Label INIT-WID-LINK
  Required-Label APP-INIT-VOC-LINK	\ SFPxxx
  Required-Label APP-INIT-WID-LINK	\ SFPxxx

  Required-Label INIT-RAM
  Required-Label INIT-FENCE
  Required-Label INIT-DP
  Required-Label INIT-RP
  Required-Label APP-INIT-RAM		\ SFPxxx
  Required-Label APP-INIT-FENCE		\ SFPxxx
  Required-Label APP-INIT-DP		\ SFPxxx

  Required-Label DODOES
  Required-Label DOCREATE
  Required-Label CLD1

\  Required-Label RAM-START
\  Required-Label ORIGIN

  Required-Label L$1
  Required-Label L$2
  Required-Label L$3
  Required-Label L$4
  Required-Label L$5
  Required-Label L$6
  Required-Label L$7
  Required-Label L$8
  Required-Label L$9
  Required-Label L$10


\ Required equates ......................          Jon 30/01/89

\  Required-Equ EM
  Required-Equ HEADS?
  Required-Equ END-OF-ROM
\ !! Required-Equ UMBILICAL?                                                    \ MSD006 \ MSD001
  Required-Equ TESTCODE?                                                        \ MSD001

harvard? [if]
  Required-Symbol C,(R)
  Required-Symbol W,(R)
  Required-Symbol ,(R)
  Required-Symbol THERE
  Required-Label  APP-INIT-RP		\ SFPxxx
[then]

only forth definitions
