\ cross compiler memory map and management variables

((
        XC-MAP-1.FTH
        cross compiler memory map and management variables

        Copyright (c) 1993-96

        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: (+44) 2380 631441
        net: mpe@mpeforth.com


To do
=====
Change search order to 32 max.

ChangeHistory
=============
20090407 SFP014 Added LASTCG(T) - pointer to target's code generator.
		Added IMMVALS(T) - set true if target values are immediate
20000726 SFP013	Added WID-LINK(T) #WID-THREADS(T)

        JL001   23 August 96
                Added flag for control structure selection.

        JL002   24 October 96
                Compiler compatability.

        JL003   30 October 96
                Multiple module support.

        JL004   18 November 96
                Added support for interactiev and batch mode, interactive is default.

        SFP005  10 Jan 97
                Added IRT-COUNT

        SFP006  5 Feb 97
                Added DATA-MODE - selects CDATA, UDATA, IDATA

        JL007   21 Feb 97
                Added support for partial compilation.

        MSD008  19 Mar 98
                Added handling of the new /IDE command-line parameter.

        MSD009  24 Apr 98
                Added /PAGEOFF facilities.

        MSD010  24 Apr 98
                Added /COLS facilities.

        SFP011  20 Aug 1998
                Added DO-RUNTIME

        SFP012  20 May 1999
                Added ?ALIGNING-INLINE
))


\ file control

only Forth also c-c definitions


\ Portability ...................          Jon 28/07/88
\

alias @(m) @
alias !(m) !
alias c@(m) c@
alias c!(m) c!
alias on(m) on
alias off(m) off
alias +!(m) +!
alias cmove(m) cmove                                    \ *** JL007 ***


\ Management-var ?Management-Addr Management-lab   Jon 20/07/88
\
                                        \
decimal                                 \
Variable Management-Addr                \ use only by building
                                        \ words
{Symbol-Management Management-Addr !    \
                                        \
: Management-Addr@                      \ -- n
  Management-Addr @                     \
;                                       \

                                        \
: Management-lab                        \ --
  Management-addr@ constant             \
;                                       \


\ Management-var ?Management-Addr .......          Jon 28/07/88
\
                                                \
decimal                                         \
                                                \
: ?Management-Addr                              \ --
  Management-addr@ }Symbol-Management 10 - u>   \ Enough space?
  abort" Out of Symbol Management space" ;      \  error if not
                                                \
: Management-Var                                \ -- [Parent]
  ?management-addr                              \ -- addr [Chd]
  management-addr@ constant                     \
  cell management-addr +!                       \
;                                               \


\ Allot(m) ..............................          Jon 20/07/88
\
                                      \
: Allot(m)                            \ n --
  Management-Addr +!                  \
  ?management-addr                    \
;                                     \
                                      \

\ ,(m) c,(m) ............................          Jon 28/07/88
\
                                      \
: ,(m)                                \ n --
  Management-Addr@ !(m)               \
  cell Management-Addr +!             \
  ?management-addr                    \
;                                     \
                                      \
: C,(m)                               \ c --
  Management-Addr@ c!(m)              \
  1 Management-Addr +!                \
  ?management-addr                    \
;                                     \
                                      \
\ Host Forth section for Symbol management         Jon 05/01/89
\
                                      \
decimal                               \
8 cell* Constant Vsize(s)             \ size of Context

\ JL007
80 constant /imgname(m)               \ size of image file name buffer for partial compilation


\ Start mapping Symbol management space .          Jon 05/01/89
\
  Management-lab Rfu(m) 32 allot(m)   \ RFU  [ 32 bytes ]
  Management-lab Int(m) 32 allot(m)   \ Internal [ 32 bytes ]
  Management-var Current(s)           \ Current for symbols
  Management-lab Context(s)           \ Context for symbols
                 Vsize(s) allot(m)    \  reserve Context space
  Management-var Voc-Link(s)          \ Voc-Link for symbols
  Management-var Dp(s)                \ Symbol space DP
  Management-var Dp(t)                \ Target dict. pointer
  Management-var Last(s)              \ last symbol created
  Management-var Last(t)              \ nfa of last target word
  Management-var LastCG(t)	\ Code Generator Field of last
				\ target word, see VFXhead.fth ; SFP014
  Management-var ImmVals(t)	\ true if target values are immediate
    -1 ImmVals(t) !(m)
  Management-var 'Latest(s)           \ last symbol in target
  Management-var State(t)             \ State of target
  Management-var Host-Mode            \ True for normal compiler
  Management-var Ram-Size             \
  Management-var Sb#                  \
  Management-var Ram-Area             \
  Management-var ?Rom                 \
  Management-var ?Log                 \
\  Management-var Rp                   \
  Management-var Rp(t)
  Management-var Up(t)
  Management-var O-I                  \
  Management-var Fence(t)             \
  Management-var Curr                 \
  Management-var Common-Ram(t)        \
  Management-var #Lines               \
  Management-var All-Res              \
  Management-var LogOut               \
  Management-var Emulator-Out         \
  Management-var ?Aligning            \ how PFAs are aligned
  Management-var ?Aligning-Inline     \ how header data (but not links) are aligned
  Management-var ?Bounding            \
  Management-var Cont                 \
  Management-var Next-Prom            \
  Management-var Min-Space            \
  Management-var Prom-Size            \
  Management-var Prom-Offset          \
  Management-var Width(t)             \ Target width
  Management-var Ref1                 \ Forward ref#1
  Management-var Ref2                 \ Forward ref#2
  Management-var 'Latest:             \ Latest ':' symbol
  Management-var 'LatestCode          \ Latest CODE symbol
  Management-var Voc-Link(t)          \ Voc-Link for target
  Management-var Wid-Link(t)	      \ Wid-Link for target ; SFP013
  Management-var #Wid-Threads(t)      \ Number of threads in a wordlist
    #16 #Wid-Threads(t) !(m)
  Management-var Do-Build             \ Flag compile-in-host
  Management-var Do-Runtime           \ Flag resolve-runtime-in-host
  Management-var ?Smudge              \
  Management-var #Logged              \
  Management-var #forward             \ number of forward refs.
  Management-var 'Equates(s)          \ Voc symbol address
  Management-var 'Labels(s)           \ Voc symbol address
  Management-var 'Forth(s)            \ Voc symbol address
  Management-var 'Page(s)             \ Voc symbol address
  Management-var 'Root(s)             \ Voc symbol address
  Management-var Cont(s)              \ storage for voc env.
  Management-var Curr(s)              \
  Management-var irt-count            \ How much of IRT used
  Management-var #redefined           \ number of redefined symbols


\ *jl*
\ *** PROCIC 2/9/93 ***
  Management-var Host-Node              \ node ids for messages
  Management-var Target-Node            \

\ *jl*
\ *** PROCIC 2/9/93 ***
  Management-var Host-Sec               \ node sections for messages
  Management-var Target-Sec             \

\ -- J Lee .. 30/10/93
  Management-var Code-Base              \ base addr. of current target prog.
  Management-var Data-Base              \ base addr. of current target data
  Management-var Prog-Base              \ base for interactive compilation
  Management-var Var-Base               \ base for interactive variables

  Management-var In-Umbilical           \ TRUE if in Umbilical Forth mode

\ -- J Lee .. 4/11/93
  Management-var Prog-ID                \ ID of target program

\ -- J Lee .. 16/11/93
  Management-var Run-XC                 \ Has Xcompiler been run
  Run-XC off(m)                         \   default is no

\ -- J Lee .. 26/11/93
  Management-var Target-Type            \ Target Cell Type
  Management-var Byte-Swap              \ Flag for target COFF byte swap

\ -- J Lee .. 6/1/94
  Management-var Max-Data               \ maximum size of data section


\ -- J Lee .. 15 April 96
  Management-var +Offset                \ flag to determine whether to lay offset for DO or not

\ JL001
  Management-var mpe-controls           \ flag to determine whether using MPE control structures (TRUE)

\ JL002
  Management-var in-host-build          \ flag whether we're building into host

\ JL003
  Management-var from-running           \ flag whether a FROM has been used
  Management-var from-memory            \ address of memory used for exports

\ JL004
  Management-var interactive-run        \ flag whether launched interactively
    interactive-run on(m)               \   default to TRUE

\ SFP006
  Management-var data-mode              \ controls action of , c, ...

\ JL007
  Management-lab imgname(m)             \ buffer for image filename with partial compilation
        /imgname(m) allot(m)

  Management-var ide-hosted             \ flag whether launched from IDE        \ MSD008
    ide-hosted off(m)                   \   default to FALSE                    \ MSD008

  Management-var want-pages             \ flag whether page-throws required     \ MSD009
    want-pages on(m)                    \   default to TRUE                     \ MSD009

  Management-var logs-per-line          \ number of log columns per line        \ MSD010
     -1 logs-per-line !(m)              \   default to a "rogue" value          \ MSD010

only forth definitions
