\ RebootCM4.fth - Reboots Cortex-M3 CPUs

((
Copyright (c) 2010, 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal

\ ==========
\ *! rebootcm3
\ *T Rebooting the CPU
\ ==========
\ *P The word *\fo{REBOOT} permits the system to be reset by
\ ** disabling all interrupts and activating the SYSRESETREQ bit
\ ** in the NVIC AIRCR register.

: reboot	\ --
\ *G Reboots the CPU by activating the watchdog.
  di dfi
  $05FA:0004 _SCS scsAIRCR + !
  begin again				\ wait for reset
;


\ ======
\ *> ###
\ ======

decimal

