\ rebootNUC1xx.fth - Reboots Nuvoton NUC1xx CPUs

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20110705 MPE001 Updated from LPC17xx version.
))

decimal

\ ==========
\ *! rebootNUC1xx
\ *T Rebooting the CPU
\ ==========
\ *P The word *\fo{REBOOT} permits the system to be reset by
\ ** disabling all interrupts and activating the watchdog.

: reboot	\ --
\ *G Reboots the CPU by activating the watchdog.
  di
  UnProtRegs
  bit3 _CLK PWRCON + or!		\ enable 10KHz clock
  $03 _CLK CLKSEL1 + or!		\ watchdog from 10 KHz clock
  bit0 _CLK APBCLK + or!		\ enable watchdog
  $0082 _WDT WTCR + !			\ start watchdog
  begin again				\ wait for reset
;


\ ======
\ *> ###
\ ======

decimal

