
$40014000 constant IO_BANK0_BASE  \ *G Base address for pin configuration
$D0000000 constant SIO_BASE       \ *G Base address for pin access
$D0000004 constant GPIO_IN        \ *G GPIO input value
$D0000010 constant GPIO_OUT       \ *G GPIO output value
$D0000020 constant GPIO_OE        \ *G GPIO output enable

: helloworld \ --
\ *G A blinker, the "Hello World" for a microcontroller.
\ ** Blinks LED on GPIO pin 25.

  5 IO_BANK0_BASE 25 8 * + 4 + !  \ Configure pin 25 for SIO (software IO), function 5.

  1 25 lshift GPIO_OE !           \ Set pin 25 as output

  begin
    1 25 lshift GPIO_OUT !        \ LED on
    200 ms
    0 GPIO_OUT !                  \ LED off
    500 ms
  key? until
;
