((
Copyright (c) 2007-2012
Synics AG

tel: +41 (0)44 840 40 60
net: info@synics.ch
web: www.synics.ch
))

\ ------------ target bindings --------------------

external

\ port bit usage (in or out)
\  |       bit index
\  |       |    port number
\  |       |    |     object property (normal or active low)
\  |       |    |     |              object name
\  |       |    |     |              |
\  v       v    v     v              v

OutputMode 25MHZ_ms      4   fp0  port_bit_object OBJ_IO_SSEL
bit_out     5   fp0  port_bit_object OBJ_ARM_SSEL

7 equ SCLK1_BIT
9 equ MOSI1_BIT
8 equ MISO1_BIT

bit_out_r SCLK1_BIT fp0  port_bit_object OBJ_SCLK1
bit_out_r MOSI1_BIT fp0  port_bit_object OBJ_MOSI1
bit_in    MISO1_BIT fp0  port_bit_object OBJ_MISO1

bit_out    21   fp0  port_bit_object OBJ_WDOG

bit_out    22   fp0  port_bit_object OBJ_BINOUT_LIFE

bit_out    25   fp0  port_bit_object OBJ_AD1_LOAD
bit_out    26   fp0  port_bit_object OBJ_AD2_LOAD

bit_out    17   fp0  port_bit_object OBJ_RS485_DIR

bit_out     0   fp1  port_bit_object_actlow OBJ_LED1
bit_out     1   fp1  port_bit_object_actlow OBJ_LED2
bit_out     4   fp1  port_bit_object_actlow OBJ_LED3
bit_out     8   fp1  port_bit_object_actlow OBJ_LED4

bit_out    25   fp1  port_bit_object_actlow OBJ_M_WP
bit_out    21   fp1  port_bit_object_actlow OBJ_M_CS

bit_out     9   fp1  port_bit_object OBJ_REL6
bit_out    10   fp1  port_bit_object OBJ_REL7
bit_out    14   fp1  port_bit_object OBJ_REL8

bit_in     18   fp1  port_bit_object OBJ_FIN0
bit_in     19   fp1  port_bit_object OBJ_FIN1

bit_out_r  20   fp1  port_bit_object OBJ_SCLK0
bit_out_r  24   fp1  port_bit_object OBJ_MOSI0
bit_in     23   fp1  port_bit_object OBJ_MISO0

bit_out    29   fp1  port_bit_object OBJ_CS_M
bit_out    25   fp1  port_bit_object OBJ_WP_M
bit_out    27   fp1  port_bit_object_actlow OBJ_FLASH_HOLD
bit_out    22   fp1  port_bit_object OBJ_ARM_SSEL0

bit_in      0   fp2  port_bit_object xxxxx            \ this bit MUST stay free on PCB 1.1, it will be harwired with P3.26 (pin 26)

bit_in      1   fp2  port_bit_object OBJ_DIGI_9
bit_in      2   fp2  port_bit_object OBJ_DIGI_10
bit_in      3   fp2  port_bit_object OBJ_DIGI_11
bit_in      4   fp2  port_bit_object OBJ_DIGI_12
bit_in      5   fp2  port_bit_object OBJ_DIGI_13
bit_in      6   fp2  port_bit_object OBJ_DIGI_14
bit_in      7   fp2  port_bit_object OBJ_DIGI_15
bit_in      8   fp2  port_bit_object OBJ_DIGI_16

bit_out    26   fp3  port_bit_object OBJ_BINOUT_DR   \ never use directly ! -> only AC,
                                                     \ defined to be sure the initialisation is low if function 0 on port bit
