#! /bin/bash
echo ******************************
echo Date changed in CortexTgt.dgs?
echo ******************************

del *.html
vfx64 include CortexTgt.dgs

rem *** generate PDF manual
echo Error log will be in manual.log
del manual.log
# *** make PDF and clean up
# *** pdftex is run three times. The first two runs generate the
# *** index twice using texindex. This ensures that the page
# *** numbers are correct in the index file. The third run is
# *** for the final manual using the index file from the second
# *** run.
# rm TEXFILES/*
rm manual.off
rm manual.fns
# cp *.tex TEXFILES/
# PDFTEXOPTS=-interaction=batchmode
PDFTEXOPTS=

pdftex $PDFTEXOPTS manual.tex
texindex manual.??
pdftex $PDFTEXOPTS manual.tex
texindex manual.??
pdftex $PDFTEXOPTS manual.tex

# *** clean up
mv manual.pdf CortexCode.pdf
cat manual.off > CortexCode.vix
cat manual.fns >> CortexCode.vix
mv manual.log cortexcode.log
rm manual.*
rm *.tex
mv cortexcode.log manual.log

mv CortexCode.* ../PDfs/
mv *.html      ../CortexCode.html/
mv *.css       ../CortexCode.html/
cp ../Images/* ../CortexCode.html/

# *** all done
echo Manual is in file CortexCode.pdf
echo Read and then delete MANUAL.LOG.


