\ TestAide.fth - test AIDE include mechanism

\ yyyyy		\ undefined word

: 2dup		( x1 x2 -- x1 x2 x1 x2 ) over over  ;
: 2drop		( x1 x2 -- )  drop drop  ;

: get-token	\ -- caddr
\ *G Get the next word of input and convert it upper case.
  bl word dup count upper  ;

: str=		\ addr1 len1 addr2 len2 -- flag
\ *G Compare two addr/len memory blocks, returning TRUE if
\ ** they are identical both in length and contents.
  rot over = if				\ -- addr1 addr2 len2
    s=  exit
  then
  2drop drop 0
;

: ParseUntil    \ c-addr u --
\ *G Read words from the input until the string is found.
  begin		\ -- a1 l1
    begin
      2dup get-token count dup
    while	\ -- a1 l1 a1 l1 a2 l2
      str=
      if  2drop  exit  then
    repeat
    2drop 2drop  query
  again
;

imm : ((	\ --
\ *G Block comment operator. Any source following this is ignored upto
\ ** and including the terminator, '))', which must be space separated.
\ ))
S" ))" ParseUntil  ;

imm : (*	\ --
\ *G Block comment operator. Any source following this is ignored upto
\ ** and including the terminator, '*)', which must be space separated.
  S" *)" ParseUntil  ;

include TestAide2.fth

(( This a test of the multiline
   comment system
))


