\ File system HTML title and menu pages, Texinfo document

\ ======
\ *! ###
\ ======
( *! filesys                                                            )
( *W <HEAD><TITLE>MPE PowerFile Manual</TITLE></HEAD>  )
( *W                                                                    )
( *W <FRAMESET COLS="250, 100%">                                        )
\ *W   <BODY bgcolor=#80C180>
( *W   <FRAME SRC="fsmenu.html"   name="menu">                          )
( *W   <FRAME SRC="fstitle.html"  name="main">                          )
\ *W   </BODY>
( *W </FRAMESET>                                                        )
( *W                                                                    )
( *W </HTML>                                                     )
\ ======
\ *> ###
\ ======


\ ==========
\ *! fstitle
\ ==========
\ *W <TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
\ *W   <TBODY>
\ *W   <TR><TD>
\ *W     <CENTER><IMG src="mpelogo.gif"></CENTER>
\ *W   </TD></TR>
\ *W   </TBODY>
\ *W </TABLE>

\ *W <CENTER>
\ *W <H1>PowerFile Software documentation</H1>
\ *W <P><I>Using MPE's VFX Forth Cross Compilers</I></P>
\ *W <P><I>Documentation derived from the source code by DOCGEN
\ *W       with VFX Forth for Windows
\ *W </I></P>
\ *W <BR><BR><BR>
\ *W <B>(C)opyright 2005 MicroProcessor Engineering Limited.</B>

\ *W <P><IMG BORDER=0 SRC="bertie.jpg"></P>

\ *W </CENTER>

\ *R @titlepage
\ \ *R @image{mpelogo}
\ *R @title                  PowerFile
\ *R @subtitle               Embedded File System
\ *R @author                 Microprocessor Engineering Limited
\ \ *R @image{bertie}
\ *R @page
\ *R 
\ *R @vskip 0pt plus 1filll
\ *R Copyright @copyright{} 1999, 2000, 2001 CEM Systems Ltd, Belfast
\ *R @*
\ *R Copyright @copyright{} 2005 Microprocessor Engineering Limited
\ *R 
\ *R Published by Microprocessor Engineering
\ *R 
\ *R 
\ *R 
\ *R @page
\ *R
\ *R MPE PowerFile                  @*
\ *R User manual                    @*
\ *R Manual revision 2.00           @*
\ *R @today{}                       @*
\ *R                                @*
\ *R                                @*
\ *R Software                       @*
\ *R Software version 2.00          @*
\ *R                                @*
\ *R                                @*
\ *R For technical support          @*
\ *R Please contact your supplier   @*
\ *R                                @*
\ *R                                @*
\ *R For further information        @*
\ *R MicroProcessor Engineering Limited    @*
\ *R 133 Hill Lane                  @*
\ *R Southampton SO15 5AF           @*
\ *R UK                             @*
\ *R                                @*
\ *R Tel:       +44 (0)23 8063 1441             @*
\ *R Fax:       +44 (0)23 8033 9691             @*
\ *R e-mail:    mpe@@mpeltd.demon.co.uk         @*
\ *R   tech-support@@mpeltd.demon.co.uk         @*
\ *R web:       www.mpeltd.demon.co.uk          @*
\ *R                                @*
\ *R @page
( *R @end titlepage
\ ======
\ *> ###
\ ======


\ ===========
\ *! fsmenu
\ ===========
\ *W <A target="main" HREF="fsintro.html">   Overview</A><BR>
\ *W <A target="main" HREF="ansfile.html">   ANS Forth file interface</A><BR>
\ *W <A target="main" HREF="fstools.html">   Command line tools</A><BR>
\ *W <A target="main" HREF="fsconfig.html">  Configuration</A><BR>
\ *W <A target="main" HREF="harness.html">   Portability Harness</A><BR>
\ *W <A target="main" HREF="structs.html">   File system structures</A><BR>
\ *W <A target="main" HREF="disk24c512.html">Disk driver for serial EEPROM</A><BR>
\ *W <A target="main" HREF="dcache.html">    Disk Cache</A><BR>
\ *W <A target="main" HREF="hdio2.html">     Intermediate Disk Read/Write</A><BR>
\ *W <A target="main" HREF="fsbitmap.html">  Disk Usage Bitmap</A><BR>
\ *W <A target="main" HREF="fcb.html">       File Control Blocks</A><BR>
\ *W <A target="main" HREF="dirparse.html">  Directory name parsing</A><BR>
\ *W <A target="main" HREF="filemain.html">  Native API</A><BR>
\ *W <A target="main" HREF="fsdiags.html">   Diagnostic tools</A><BR>
\ ======
\ *> ###
\ ======


\ ===========
\ *! fsmanual
\ ===========
\ *R \input texinfo
\ *R @setfilename            PowerFile.info
\ *R @setcontentsaftertitlepage
\ *R @afourpaper
\ *R @settitle               PowerFile Code Manual
\ *R @setchapternewpage      odd
\ *R @paragraphindent        0
\ *R @exampleindent          0
\ *R @finalout

\ *R @include fstitle
\ *R @include fsintro
\ *R @include ansfile
\ *R @include fstools
\ *R @include fsconfig
\ *R @include harness
\ *R @include structs
\ *R @include disk24c512
\ *R @include dcache
\ *R @include hdio2
\ *R @include fsbitmap
\ *R @include fcb
\ *R @include dirparse
\ *R @include filemain
\ *R @include fsdiags

\ *R @unnumbered{Index}
\ *R @*
\ *R @printindex fn

\ *R @bye
\ ======
\ *> ###
\ ======


