\ FtpDir.fth - directory listing for FTP server

((
Copyright (c) 2007, 2008, 2009, 2013
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)

To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! ftpdir
\ *T Directory listing for FTP
\ ===========
\ *P Each line of the display is "sort of" in Unix ls format.

\ *E ----------   1 owner    group         1803128 Jul 10 10:18 ls-lR.Z
\ ** d---------   1 owner    group               0 May  9 19:45 Softlib

: .ftpDirLine	\ --
\ *G Display a directory entry in FTP format
  folder?
  if  ." d"  else  ." -"  endif
  ." --------- 1 owner group "
  dsize 13 .r space
  d-date space d-time space d-name cr
;

: .ftpdir	\ --
\ *G Display list of file names in FTP format.
  dirhome  get-es  todir DirValid? if
    begin
      dir?				\ valid entry
     while				\ --
      .ftpDirLine dirnext 0=
    until then
  then
  set-es
;


\ ======
\ *> ###
\ ======

decimal

