\ *! rfcs
\ *T Internet RFCs
\ =======
\ ******************
\ *S What is an RFC?
\ ******************
\ *P Internet standards are generally proposed and honed by various
\ ** commitees in public documents across the World Wide Web. These
\ ** documents are called RFCs (Request for Comments). For any
\ ** standard protocol you will find a number of these documents on the
\ ** Web. Some relevant ones are in the *\i{M} directory.

\ *********************************
\ *S Where are the latest versions?
\ *********************************
\ *P The web site *\f{http://www.rfc-editor.org} is currently the
\ ** best source for finding RFCs.

\ *P Another starting place for a search engine; you can find them
\ ** simply by entering the phrase:-
\ *C   <protocol> +RFC
\ *P into the search engine. When looking up a protocol be aware
\ ** of two things:-
\ *( 1
\ *B Sometimes an RFC describing a protocol is made obsolescent
\ ** by a later document.
\ *B Most protocols have extension documents posted after their
\ ** initial release.
\ *)


\ **********************
\ *S Recommended reading
\ **********************
\ *P TCP/IP Illustrated volume 1 *\br{}
\ ** W Richard Stevens *\br{}
\ ** ADDISON WESLEY

\ *P TCP/IP Illustrated volume 2 *\br{}
\ ** Gary R Wight & W Richard Stevens *\br{}
\ ** ADDISON WESLEY

\ *P InterNetworking with TCP/IP vol 2 *\br{}
\ ** Douglas E Comer & David L Stevens *\br{}
\ ** PRENTICE HALL

\ *P Net BSD Sources *\br{}
\ ** Net BSD Man Pages *\br{}
\ ** The Linux sources will do fine
\ *C   http://www.linux.org

\ \ *P A howto on protocol design.
\ \ *C   http://spectral.mscs.mu.edu/RFC/folklore.html


\ ******
\ *> ###
\ ******
