\ UsbTests.fth - USB performance tests

Extern: BOOL WINAPI FlushFileBuffers( HANDLE hFile );
\ Returns 0=fail

create szSF	\ -- addr ; source file name
  z", C:\buildkit.dev\software\ROM\Examples\USB\Notes\usb_20.pdf"
create szDF	\ -- addr ; dest file name
  z", D:\usb_20.pdf"

: CFWtest	\ -- ; write file test
  szDF zcount delete-file drop
  szSF zcount inhale				\ -- caddr len
  timer-reset
  szDF zcount r/w create-file abort" Err: create"	\ -- caddr len fid
  dup >r write-file abort" Err: write"
  r> close-file abort" Err: close"
  .elapsed
  burp
;

: CFRtest	\ -- ; read file test
  timer-reset
  szDF zcount inhale 2drop  burp
  .elapsed
;


((
usb_20.pdf - 5,983,789 bytes, 47,870,312 bits
CFWtest - PC to LPC23xx SD card
Base - 36630 ms
CFRtest - LPC23xx SD card to PC - reset card first to flush
the disk cache.
Base - 11562 ms
))